<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AccAliasesListInfo StructType
 * @subpackage Structs
 */
class AccAliasesListInfo extends AbstractStructBase
{
    /**
     * The i_master_account
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_master_account;
    /**
     * The master_account_id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $master_account_id;
    /**
     * The i_account
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_account;
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $id;
    /**
     * The blocked
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $blocked;
    /**
     * Constructor method for AccAliasesListInfo
     * @uses AccAliasesListInfo::setI_master_account()
     * @uses AccAliasesListInfo::setMaster_account_id()
     * @uses AccAliasesListInfo::setI_account()
     * @uses AccAliasesListInfo::setId()
     * @uses AccAliasesListInfo::setBlocked()
     * @param int $i_master_account
     * @param string $master_account_id
     * @param int $i_account
     * @param string $id
     * @param string $blocked
     */
    public function __construct($i_master_account = null, $master_account_id = null, $i_account = null, $id = null, $blocked = null)
    {
        $this
            ->setI_master_account($i_master_account)
            ->setMaster_account_id($master_account_id)
            ->setI_account($i_account)
            ->setId($id)
            ->setBlocked($blocked);
    }
    /**
     * Get i_master_account value
     * @return int|null
     */
    public function getI_master_account()
    {
        return $this->i_master_account;
    }
    /**
     * Set i_master_account value
     * @param int $i_master_account
     * @return \StructType\AccAliasesListInfo
     */
    public function setI_master_account($i_master_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_master_account) && !is_numeric($i_master_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_master_account)), __LINE__);
        }
        $this->i_master_account = $i_master_account;
        return $this;
    }
    /**
     * Get master_account_id value
     * @return string|null
     */
    public function getMaster_account_id()
    {
        return $this->master_account_id;
    }
    /**
     * Set master_account_id value
     * @param string $master_account_id
     * @return \StructType\AccAliasesListInfo
     */
    public function setMaster_account_id($master_account_id = null)
    {
        // validation for constraint: string
        if (!is_null($master_account_id) && !is_string($master_account_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($master_account_id)), __LINE__);
        }
        $this->master_account_id = $master_account_id;
        return $this;
    }
    /**
     * Get i_account value
     * @return int|null
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\AccAliasesListInfo
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\AccAliasesListInfo
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get blocked value
     * @return string|null
     */
    public function getBlocked()
    {
        return $this->blocked;
    }
    /**
     * Set blocked value
     * @param string $blocked
     * @return \StructType\AccAliasesListInfo
     */
    public function setBlocked($blocked = null)
    {
        // validation for constraint: string
        if (!is_null($blocked) && !is_string($blocked)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($blocked)), __LINE__);
        }
        $this->blocked = $blocked;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AccAliasesListInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
