<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddCurrencyRequest StructType
 * @subpackage Structs
 */
class AddCurrencyRequest extends AbstractStructBase
{
    /**
     * The currency_info
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\CurrencyInfo
     */
    public $currency_info;
    /**
     * Constructor method for AddCurrencyRequest
     * @uses AddCurrencyRequest::setCurrency_info()
     * @param \StructType\CurrencyInfo $currency_info
     */
    public function __construct(\StructType\CurrencyInfo $currency_info = null)
    {
        $this
            ->setCurrency_info($currency_info);
    }
    /**
     * Get currency_info value
     * @return \StructType\CurrencyInfo
     */
    public function getCurrency_info()
    {
        return $this->currency_info;
    }
    /**
     * Set currency_info value
     * @param \StructType\CurrencyInfo $currency_info
     * @return \StructType\AddCurrencyRequest
     */
    public function setCurrency_info(\StructType\CurrencyInfo $currency_info = null)
    {
        $this->currency_info = $currency_info;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddCurrencyRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
