<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddCustomerExtensionRequest StructType
 * @subpackage Structs
 */
class AddCustomerExtensionRequest extends AbstractStructBase
{
    /**
     * The i_customer
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $i_customer;
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $id;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The i_account
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_account;
    /**
     * The prompt_action
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $prompt_action;
    /**
     * The published
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $published;
    /**
     * Constructor method for AddCustomerExtensionRequest
     * @uses AddCustomerExtensionRequest::setI_customer()
     * @uses AddCustomerExtensionRequest::setId()
     * @uses AddCustomerExtensionRequest::setName()
     * @uses AddCustomerExtensionRequest::setI_account()
     * @uses AddCustomerExtensionRequest::setPrompt_action()
     * @uses AddCustomerExtensionRequest::setPublished()
     * @param int $i_customer
     * @param string $id
     * @param string $name
     * @param int $i_account
     * @param string $prompt_action
     * @param string $published
     */
    public function __construct($i_customer = null, $id = null, $name = null, $i_account = null, $prompt_action = null, $published = null)
    {
        $this
            ->setI_customer($i_customer)
            ->setId($id)
            ->setName($name)
            ->setI_account($i_account)
            ->setPrompt_action($prompt_action)
            ->setPublished($published);
    }
    /**
     * Get i_customer value
     * @return int
     */
    public function getI_customer()
    {
        return $this->i_customer;
    }
    /**
     * Set i_customer value
     * @param int $i_customer
     * @return \StructType\AddCustomerExtensionRequest
     */
    public function setI_customer($i_customer = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer) && !is_numeric($i_customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer)), __LINE__);
        }
        $this->i_customer = $i_customer;
        return $this;
    }
    /**
     * Get id value
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\AddCustomerExtensionRequest
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\AddCustomerExtensionRequest
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get i_account value
     * @return int|null
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\AddCustomerExtensionRequest
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Get prompt_action value
     * @return string|null
     */
    public function getPrompt_action()
    {
        return $this->prompt_action;
    }
    /**
     * Set prompt_action value
     * @param string $prompt_action
     * @return \StructType\AddCustomerExtensionRequest
     */
    public function setPrompt_action($prompt_action = null)
    {
        // validation for constraint: string
        if (!is_null($prompt_action) && !is_string($prompt_action)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prompt_action)), __LINE__);
        }
        $this->prompt_action = $prompt_action;
        return $this;
    }
    /**
     * Get published value
     * @return string|null
     */
    public function getPublished()
    {
        return $this->published;
    }
    /**
     * Set published value
     * @param string $published
     * @return \StructType\AddCustomerExtensionRequest
     */
    public function setPublished($published = null)
    {
        // validation for constraint: string
        if (!is_null($published) && !is_string($published)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($published)), __LINE__);
        }
        $this->published = $published;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddCustomerExtensionRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
