<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddRateGroupRequest StructType
 * @subpackage Structs
 */
class AddRateGroupRequest extends AbstractStructBase
{
    /**
     * The i_dest_group
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $i_dest_group;
    /**
     * The rate_info
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\RateInfo
     */
    public $rate_info;
    /**
     * Constructor method for AddRateGroupRequest
     * @uses AddRateGroupRequest::setI_dest_group()
     * @uses AddRateGroupRequest::setRate_info()
     * @param int $i_dest_group
     * @param \StructType\RateInfo $rate_info
     */
    public function __construct($i_dest_group = null, \StructType\RateInfo $rate_info = null)
    {
        $this
            ->setI_dest_group($i_dest_group)
            ->setRate_info($rate_info);
    }
    /**
     * Get i_dest_group value
     * @return int
     */
    public function getI_dest_group()
    {
        return $this->i_dest_group;
    }
    /**
     * Set i_dest_group value
     * @param int $i_dest_group
     * @return \StructType\AddRateGroupRequest
     */
    public function setI_dest_group($i_dest_group = null)
    {
        // validation for constraint: int
        if (!is_null($i_dest_group) && !is_numeric($i_dest_group)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_dest_group)), __LINE__);
        }
        $this->i_dest_group = $i_dest_group;
        return $this;
    }
    /**
     * Get rate_info value
     * @return \StructType\RateInfo
     */
    public function getRate_info()
    {
        return $this->rate_info;
    }
    /**
     * Set rate_info value
     * @param \StructType\RateInfo $rate_info
     * @return \StructType\AddRateGroupRequest
     */
    public function setRate_info(\StructType\RateInfo $rate_info = null)
    {
        $this->rate_info = $rate_info;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddRateGroupRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
