<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddUpdateAuthzRuleRequest StructType
 * @subpackage Structs
 */
class AddUpdateAuthzRuleRequest extends AbstractStructBase
{
    /**
     * The authz_rule_info
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\AuthzRuleInfo
     */
    public $authz_rule_info;
    /**
     * The override_autogenerated
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $override_autogenerated;
    /**
     * Constructor method for AddUpdateAuthzRuleRequest
     * @uses AddUpdateAuthzRuleRequest::setAuthz_rule_info()
     * @uses AddUpdateAuthzRuleRequest::setOverride_autogenerated()
     * @param \StructType\AuthzRuleInfo $authz_rule_info
     * @param int $override_autogenerated
     */
    public function __construct(\StructType\AuthzRuleInfo $authz_rule_info = null, $override_autogenerated = null)
    {
        $this
            ->setAuthz_rule_info($authz_rule_info)
            ->setOverride_autogenerated($override_autogenerated);
    }
    /**
     * Get authz_rule_info value
     * @return \StructType\AuthzRuleInfo
     */
    public function getAuthz_rule_info()
    {
        return $this->authz_rule_info;
    }
    /**
     * Set authz_rule_info value
     * @param \StructType\AuthzRuleInfo $authz_rule_info
     * @return \StructType\AddUpdateAuthzRuleRequest
     */
    public function setAuthz_rule_info(\StructType\AuthzRuleInfo $authz_rule_info = null)
    {
        $this->authz_rule_info = $authz_rule_info;
        return $this;
    }
    /**
     * Get override_autogenerated value
     * @return int|null
     */
    public function getOverride_autogenerated()
    {
        return $this->override_autogenerated;
    }
    /**
     * Set override_autogenerated value
     * @param int $override_autogenerated
     * @return \StructType\AddUpdateAuthzRuleRequest
     */
    public function setOverride_autogenerated($override_autogenerated = null)
    {
        // validation for constraint: int
        if (!is_null($override_autogenerated) && !is_numeric($override_autogenerated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($override_autogenerated)), __LINE__);
        }
        $this->override_autogenerated = $override_autogenerated;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddUpdateAuthzRuleRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
