<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AliasInfo StructType
 * @subpackage Structs
 */
class AliasInfo extends AbstractStructBase
{
    /**
     * The i_master_account
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_master_account;
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $id;
    /**
     * The blocked
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $blocked;
    /**
     * The i_account
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_account;
    /**
     * Constructor method for AliasInfo
     * @uses AliasInfo::setI_master_account()
     * @uses AliasInfo::setId()
     * @uses AliasInfo::setBlocked()
     * @uses AliasInfo::setI_account()
     * @param int $i_master_account
     * @param string $id
     * @param string $blocked
     * @param int $i_account
     */
    public function __construct($i_master_account = null, $id = null, $blocked = null, $i_account = null)
    {
        $this
            ->setI_master_account($i_master_account)
            ->setId($id)
            ->setBlocked($blocked)
            ->setI_account($i_account);
    }
    /**
     * Get i_master_account value
     * @return int|null
     */
    public function getI_master_account()
    {
        return $this->i_master_account;
    }
    /**
     * Set i_master_account value
     * @param int $i_master_account
     * @return \StructType\AliasInfo
     */
    public function setI_master_account($i_master_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_master_account) && !is_numeric($i_master_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_master_account)), __LINE__);
        }
        $this->i_master_account = $i_master_account;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\AliasInfo
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get blocked value
     * @return string|null
     */
    public function getBlocked()
    {
        return $this->blocked;
    }
    /**
     * Set blocked value
     * @param string $blocked
     * @return \StructType\AliasInfo
     */
    public function setBlocked($blocked = null)
    {
        // validation for constraint: string
        if (!is_null($blocked) && !is_string($blocked)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($blocked)), __LINE__);
        }
        $this->blocked = $blocked;
        return $this;
    }
    /**
     * Get i_account value
     * @return int|null
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\AliasInfo
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AliasInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
