<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AssignUARequest StructType
 * @subpackage Structs
 */
class AssignUARequest extends AbstractStructBase
{
    /**
     * The i_account
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $i_account;
    /**
     * The i_ua
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $i_ua;
    /**
     * The port
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $port;
    /**
     * Constructor method for AssignUARequest
     * @uses AssignUARequest::setI_account()
     * @uses AssignUARequest::setI_ua()
     * @uses AssignUARequest::setPort()
     * @param int $i_account
     * @param int $i_ua
     * @param int $port
     */
    public function __construct($i_account = null, $i_ua = null, $port = null)
    {
        $this
            ->setI_account($i_account)
            ->setI_ua($i_ua)
            ->setPort($port);
    }
    /**
     * Get i_account value
     * @return int
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\AssignUARequest
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Get i_ua value
     * @return int
     */
    public function getI_ua()
    {
        return $this->i_ua;
    }
    /**
     * Set i_ua value
     * @param int $i_ua
     * @return \StructType\AssignUARequest
     */
    public function setI_ua($i_ua = null)
    {
        // validation for constraint: int
        if (!is_null($i_ua) && !is_numeric($i_ua)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_ua)), __LINE__);
        }
        $this->i_ua = $i_ua;
        return $this;
    }
    /**
     * Get port value
     * @return int
     */
    public function getPort()
    {
        return $this->port;
    }
    /**
     * Set port value
     * @param int $port
     * @return \StructType\AssignUARequest
     */
    public function setPort($port = null)
    {
        // validation for constraint: int
        if (!is_null($port) && !is_numeric($port)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($port)), __LINE__);
        }
        $this->port = $port;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AssignUARequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
