<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AssignedExtensionsInfo StructType
 * @subpackage Structs
 */
class AssignedExtensionsInfo extends AbstractStructBase
{
    /**
     * The i_cg_ext
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_cg_ext;
    /**
     * The i_c_ext
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_c_ext;
    /**
     * The i_c_group
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_c_group;
    /**
     * The type
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $type;
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $id;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The huntstop
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $huntstop;
    /**
     * The primary_group
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $primary_group;
    /**
     * The hunt_delay
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $hunt_delay;
    /**
     * The hunt_expire
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $hunt_expire;
    /**
     * The hunt_order
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $hunt_order;
    /**
     * The account_id
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $account_id;
    /**
     * Constructor method for AssignedExtensionsInfo
     * @uses AssignedExtensionsInfo::setI_cg_ext()
     * @uses AssignedExtensionsInfo::setI_c_ext()
     * @uses AssignedExtensionsInfo::setI_c_group()
     * @uses AssignedExtensionsInfo::setType()
     * @uses AssignedExtensionsInfo::setId()
     * @uses AssignedExtensionsInfo::setName()
     * @uses AssignedExtensionsInfo::setHuntstop()
     * @uses AssignedExtensionsInfo::setPrimary_group()
     * @uses AssignedExtensionsInfo::setHunt_delay()
     * @uses AssignedExtensionsInfo::setHunt_expire()
     * @uses AssignedExtensionsInfo::setHunt_order()
     * @uses AssignedExtensionsInfo::setAccount_id()
     * @param int $i_cg_ext
     * @param int $i_c_ext
     * @param int $i_c_group
     * @param string $type
     * @param string $id
     * @param string $name
     * @param string $huntstop
     * @param string $primary_group
     * @param int $hunt_delay
     * @param int $hunt_expire
     * @param int $hunt_order
     * @param string $account_id
     */
    public function __construct($i_cg_ext = null, $i_c_ext = null, $i_c_group = null, $type = null, $id = null, $name = null, $huntstop = null, $primary_group = null, $hunt_delay = null, $hunt_expire = null, $hunt_order = null, $account_id = null)
    {
        $this
            ->setI_cg_ext($i_cg_ext)
            ->setI_c_ext($i_c_ext)
            ->setI_c_group($i_c_group)
            ->setType($type)
            ->setId($id)
            ->setName($name)
            ->setHuntstop($huntstop)
            ->setPrimary_group($primary_group)
            ->setHunt_delay($hunt_delay)
            ->setHunt_expire($hunt_expire)
            ->setHunt_order($hunt_order)
            ->setAccount_id($account_id);
    }
    /**
     * Get i_cg_ext value
     * @return int|null
     */
    public function getI_cg_ext()
    {
        return $this->i_cg_ext;
    }
    /**
     * Set i_cg_ext value
     * @param int $i_cg_ext
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setI_cg_ext($i_cg_ext = null)
    {
        // validation for constraint: int
        if (!is_null($i_cg_ext) && !is_numeric($i_cg_ext)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_cg_ext)), __LINE__);
        }
        $this->i_cg_ext = $i_cg_ext;
        return $this;
    }
    /**
     * Get i_c_ext value
     * @return int|null
     */
    public function getI_c_ext()
    {
        return $this->i_c_ext;
    }
    /**
     * Set i_c_ext value
     * @param int $i_c_ext
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setI_c_ext($i_c_ext = null)
    {
        // validation for constraint: int
        if (!is_null($i_c_ext) && !is_numeric($i_c_ext)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_c_ext)), __LINE__);
        }
        $this->i_c_ext = $i_c_ext;
        return $this;
    }
    /**
     * Get i_c_group value
     * @return int|null
     */
    public function getI_c_group()
    {
        return $this->i_c_group;
    }
    /**
     * Set i_c_group value
     * @param int $i_c_group
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setI_c_group($i_c_group = null)
    {
        // validation for constraint: int
        if (!is_null($i_c_group) && !is_numeric($i_c_group)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_c_group)), __LINE__);
        }
        $this->i_c_group = $i_c_group;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get huntstop value
     * @return string|null
     */
    public function getHuntstop()
    {
        return $this->huntstop;
    }
    /**
     * Set huntstop value
     * @param string $huntstop
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setHuntstop($huntstop = null)
    {
        // validation for constraint: string
        if (!is_null($huntstop) && !is_string($huntstop)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($huntstop)), __LINE__);
        }
        $this->huntstop = $huntstop;
        return $this;
    }
    /**
     * Get primary_group value
     * @return string|null
     */
    public function getPrimary_group()
    {
        return $this->primary_group;
    }
    /**
     * Set primary_group value
     * @param string $primary_group
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setPrimary_group($primary_group = null)
    {
        // validation for constraint: string
        if (!is_null($primary_group) && !is_string($primary_group)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($primary_group)), __LINE__);
        }
        $this->primary_group = $primary_group;
        return $this;
    }
    /**
     * Get hunt_delay value
     * @return int|null
     */
    public function getHunt_delay()
    {
        return $this->hunt_delay;
    }
    /**
     * Set hunt_delay value
     * @param int $hunt_delay
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setHunt_delay($hunt_delay = null)
    {
        // validation for constraint: int
        if (!is_null($hunt_delay) && !is_numeric($hunt_delay)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($hunt_delay)), __LINE__);
        }
        $this->hunt_delay = $hunt_delay;
        return $this;
    }
    /**
     * Get hunt_expire value
     * @return int|null
     */
    public function getHunt_expire()
    {
        return $this->hunt_expire;
    }
    /**
     * Set hunt_expire value
     * @param int $hunt_expire
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setHunt_expire($hunt_expire = null)
    {
        // validation for constraint: int
        if (!is_null($hunt_expire) && !is_numeric($hunt_expire)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($hunt_expire)), __LINE__);
        }
        $this->hunt_expire = $hunt_expire;
        return $this;
    }
    /**
     * Get hunt_order value
     * @return int|null
     */
    public function getHunt_order()
    {
        return $this->hunt_order;
    }
    /**
     * Set hunt_order value
     * @param int $hunt_order
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setHunt_order($hunt_order = null)
    {
        // validation for constraint: int
        if (!is_null($hunt_order) && !is_numeric($hunt_order)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($hunt_order)), __LINE__);
        }
        $this->hunt_order = $hunt_order;
        return $this;
    }
    /**
     * Get account_id value
     * @return string|null
     */
    public function getAccount_id()
    {
        return $this->account_id;
    }
    /**
     * Set account_id value
     * @param string $account_id
     * @return \StructType\AssignedExtensionsInfo
     */
    public function setAccount_id($account_id = null)
    {
        // validation for constraint: string
        if (!is_null($account_id) && !is_string($account_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($account_id)), __LINE__);
        }
        $this->account_id = $account_id;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AssignedExtensionsInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
