<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CPConditionNumberInfo StructType
 * @subpackage Structs
 */
class CPConditionNumberInfo extends AbstractStructBase
{
    /**
     * The number
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $number;
    /**
     * The onnet
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $onnet;
    /**
     * Constructor method for CPConditionNumberInfo
     * @uses CPConditionNumberInfo::setNumber()
     * @uses CPConditionNumberInfo::setOnnet()
     * @param string $number
     * @param string $onnet
     */
    public function __construct($number = null, $onnet = null)
    {
        $this
            ->setNumber($number)
            ->setOnnet($onnet);
    }
    /**
     * Get number value
     * @return string
     */
    public function getNumber()
    {
        return $this->number;
    }
    /**
     * Set number value
     * @param string $number
     * @return \StructType\CPConditionNumberInfo
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($number)), __LINE__);
        }
        $this->number = $number;
        return $this;
    }
    /**
     * Get onnet value
     * @return string|null
     */
    public function getOnnet()
    {
        return $this->onnet;
    }
    /**
     * Set onnet value
     * @param string $onnet
     * @return \StructType\CPConditionNumberInfo
     */
    public function setOnnet($onnet = null)
    {
        // validation for constraint: string
        if (!is_null($onnet) && !is_string($onnet)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($onnet)), __LINE__);
        }
        $this->onnet = $onnet;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CPConditionNumberInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
