<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChangeCustomerPasswordRequest StructType
 * @subpackage Structs
 */
class ChangeCustomerPasswordRequest extends AbstractStructBase
{
    /**
     * The new_password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $new_password;
    /**
     * The old_password
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $old_password;
    /**
     * The i_customer
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_customer;
    /**
     * Constructor method for ChangeCustomerPasswordRequest
     * @uses ChangeCustomerPasswordRequest::setNew_password()
     * @uses ChangeCustomerPasswordRequest::setOld_password()
     * @uses ChangeCustomerPasswordRequest::setI_customer()
     * @param string $new_password
     * @param string $old_password
     * @param int $i_customer
     */
    public function __construct($new_password = null, $old_password = null, $i_customer = null)
    {
        $this
            ->setNew_password($new_password)
            ->setOld_password($old_password)
            ->setI_customer($i_customer);
    }
    /**
     * Get new_password value
     * @return string
     */
    public function getNew_password()
    {
        return $this->new_password;
    }
    /**
     * Set new_password value
     * @param string $new_password
     * @return \StructType\ChangeCustomerPasswordRequest
     */
    public function setNew_password($new_password = null)
    {
        // validation for constraint: string
        if (!is_null($new_password) && !is_string($new_password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($new_password)), __LINE__);
        }
        $this->new_password = $new_password;
        return $this;
    }
    /**
     * Get old_password value
     * @return string
     */
    public function getOld_password()
    {
        return $this->old_password;
    }
    /**
     * Set old_password value
     * @param string $old_password
     * @return \StructType\ChangeCustomerPasswordRequest
     */
    public function setOld_password($old_password = null)
    {
        // validation for constraint: string
        if (!is_null($old_password) && !is_string($old_password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($old_password)), __LINE__);
        }
        $this->old_password = $old_password;
        return $this;
    }
    /**
     * Get i_customer value
     * @return int|null
     */
    public function getI_customer()
    {
        return $this->i_customer;
    }
    /**
     * Set i_customer value
     * @param int $i_customer
     * @return \StructType\ChangeCustomerPasswordRequest
     */
    public function setI_customer($i_customer = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer) && !is_numeric($i_customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer)), __LINE__);
        }
        $this->i_customer = $i_customer;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ChangeCustomerPasswordRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
