<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerInvoicesListInfo StructType
 * @subpackage Structs
 */
class CustomerInvoicesListInfo extends AbstractStructBase
{
    /**
     * The is_pdf_exists
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $is_pdf_exists;
    /**
     * The invoice_number
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $invoice_number;
    /**
     * The i_invoice
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_invoice;
    /**
     * The i_customer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_customer;
    /**
     * The issue_date
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $issue_date;
    /**
     * The period_from
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $period_from;
    /**
     * The period_to
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $period_to;
    /**
     * The due_date
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $due_date;
    /**
     * The i_invoice_status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_invoice_status;
    /**
     * The invoice_status_desc
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $invoice_status_desc;
    /**
     * The amount_due
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $amount_due;
    /**
     * The amount_net
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $amount_net;
    /**
     * The amount_paid
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $amount_paid;
    /**
     * The is_void
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $is_void;
    /**
     * Constructor method for CustomerInvoicesListInfo
     * @uses CustomerInvoicesListInfo::setIs_pdf_exists()
     * @uses CustomerInvoicesListInfo::setInvoice_number()
     * @uses CustomerInvoicesListInfo::setI_invoice()
     * @uses CustomerInvoicesListInfo::setI_customer()
     * @uses CustomerInvoicesListInfo::setIssue_date()
     * @uses CustomerInvoicesListInfo::setPeriod_from()
     * @uses CustomerInvoicesListInfo::setPeriod_to()
     * @uses CustomerInvoicesListInfo::setDue_date()
     * @uses CustomerInvoicesListInfo::setI_invoice_status()
     * @uses CustomerInvoicesListInfo::setInvoice_status_desc()
     * @uses CustomerInvoicesListInfo::setAmount_due()
     * @uses CustomerInvoicesListInfo::setAmount_net()
     * @uses CustomerInvoicesListInfo::setAmount_paid()
     * @uses CustomerInvoicesListInfo::setIs_void()
     * @param int $is_pdf_exists
     * @param int $invoice_number
     * @param int $i_invoice
     * @param int $i_customer
     * @param string $issue_date
     * @param string $period_from
     * @param string $period_to
     * @param string $due_date
     * @param int $i_invoice_status
     * @param string $invoice_status_desc
     * @param string $amount_due
     * @param string $amount_net
     * @param string $amount_paid
     * @param string $is_void
     */
    public function __construct($is_pdf_exists = null, $invoice_number = null, $i_invoice = null, $i_customer = null, $issue_date = null, $period_from = null, $period_to = null, $due_date = null, $i_invoice_status = null, $invoice_status_desc = null, $amount_due = null, $amount_net = null, $amount_paid = null, $is_void = null)
    {
        $this
            ->setIs_pdf_exists($is_pdf_exists)
            ->setInvoice_number($invoice_number)
            ->setI_invoice($i_invoice)
            ->setI_customer($i_customer)
            ->setIssue_date($issue_date)
            ->setPeriod_from($period_from)
            ->setPeriod_to($period_to)
            ->setDue_date($due_date)
            ->setI_invoice_status($i_invoice_status)
            ->setInvoice_status_desc($invoice_status_desc)
            ->setAmount_due($amount_due)
            ->setAmount_net($amount_net)
            ->setAmount_paid($amount_paid)
            ->setIs_void($is_void);
    }
    /**
     * Get is_pdf_exists value
     * @return int|null
     */
    public function getIs_pdf_exists()
    {
        return $this->is_pdf_exists;
    }
    /**
     * Set is_pdf_exists value
     * @param int $is_pdf_exists
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setIs_pdf_exists($is_pdf_exists = null)
    {
        // validation for constraint: int
        if (!is_null($is_pdf_exists) && !is_numeric($is_pdf_exists)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($is_pdf_exists)), __LINE__);
        }
        $this->is_pdf_exists = $is_pdf_exists;
        return $this;
    }
    /**
     * Get invoice_number value
     * @return int|null
     */
    public function getInvoice_number()
    {
        return $this->invoice_number;
    }
    /**
     * Set invoice_number value
     * @param int $invoice_number
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setInvoice_number($invoice_number = null)
    {
        // validation for constraint: int
        if (!is_null($invoice_number) && !is_numeric($invoice_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($invoice_number)), __LINE__);
        }
        $this->invoice_number = $invoice_number;
        return $this;
    }
    /**
     * Get i_invoice value
     * @return int|null
     */
    public function getI_invoice()
    {
        return $this->i_invoice;
    }
    /**
     * Set i_invoice value
     * @param int $i_invoice
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setI_invoice($i_invoice = null)
    {
        // validation for constraint: int
        if (!is_null($i_invoice) && !is_numeric($i_invoice)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_invoice)), __LINE__);
        }
        $this->i_invoice = $i_invoice;
        return $this;
    }
    /**
     * Get i_customer value
     * @return int|null
     */
    public function getI_customer()
    {
        return $this->i_customer;
    }
    /**
     * Set i_customer value
     * @param int $i_customer
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setI_customer($i_customer = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer) && !is_numeric($i_customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer)), __LINE__);
        }
        $this->i_customer = $i_customer;
        return $this;
    }
    /**
     * Get issue_date value
     * @return string|null
     */
    public function getIssue_date()
    {
        return $this->issue_date;
    }
    /**
     * Set issue_date value
     * @param string $issue_date
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setIssue_date($issue_date = null)
    {
        // validation for constraint: string
        if (!is_null($issue_date) && !is_string($issue_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($issue_date)), __LINE__);
        }
        $this->issue_date = $issue_date;
        return $this;
    }
    /**
     * Get period_from value
     * @return string|null
     */
    public function getPeriod_from()
    {
        return $this->period_from;
    }
    /**
     * Set period_from value
     * @param string $period_from
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setPeriod_from($period_from = null)
    {
        // validation for constraint: string
        if (!is_null($period_from) && !is_string($period_from)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($period_from)), __LINE__);
        }
        $this->period_from = $period_from;
        return $this;
    }
    /**
     * Get period_to value
     * @return string|null
     */
    public function getPeriod_to()
    {
        return $this->period_to;
    }
    /**
     * Set period_to value
     * @param string $period_to
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setPeriod_to($period_to = null)
    {
        // validation for constraint: string
        if (!is_null($period_to) && !is_string($period_to)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($period_to)), __LINE__);
        }
        $this->period_to = $period_to;
        return $this;
    }
    /**
     * Get due_date value
     * @return string|null
     */
    public function getDue_date()
    {
        return $this->due_date;
    }
    /**
     * Set due_date value
     * @param string $due_date
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setDue_date($due_date = null)
    {
        // validation for constraint: string
        if (!is_null($due_date) && !is_string($due_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($due_date)), __LINE__);
        }
        $this->due_date = $due_date;
        return $this;
    }
    /**
     * Get i_invoice_status value
     * @return int|null
     */
    public function getI_invoice_status()
    {
        return $this->i_invoice_status;
    }
    /**
     * Set i_invoice_status value
     * @param int $i_invoice_status
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setI_invoice_status($i_invoice_status = null)
    {
        // validation for constraint: int
        if (!is_null($i_invoice_status) && !is_numeric($i_invoice_status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_invoice_status)), __LINE__);
        }
        $this->i_invoice_status = $i_invoice_status;
        return $this;
    }
    /**
     * Get invoice_status_desc value
     * @return string|null
     */
    public function getInvoice_status_desc()
    {
        return $this->invoice_status_desc;
    }
    /**
     * Set invoice_status_desc value
     * @param string $invoice_status_desc
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setInvoice_status_desc($invoice_status_desc = null)
    {
        // validation for constraint: string
        if (!is_null($invoice_status_desc) && !is_string($invoice_status_desc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($invoice_status_desc)), __LINE__);
        }
        $this->invoice_status_desc = $invoice_status_desc;
        return $this;
    }
    /**
     * Get amount_due value
     * @return string|null
     */
    public function getAmount_due()
    {
        return $this->amount_due;
    }
    /**
     * Set amount_due value
     * @param string $amount_due
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setAmount_due($amount_due = null)
    {
        // validation for constraint: string
        if (!is_null($amount_due) && !is_string($amount_due)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($amount_due)), __LINE__);
        }
        $this->amount_due = $amount_due;
        return $this;
    }
    /**
     * Get amount_net value
     * @return string|null
     */
    public function getAmount_net()
    {
        return $this->amount_net;
    }
    /**
     * Set amount_net value
     * @param string $amount_net
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setAmount_net($amount_net = null)
    {
        // validation for constraint: string
        if (!is_null($amount_net) && !is_string($amount_net)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($amount_net)), __LINE__);
        }
        $this->amount_net = $amount_net;
        return $this;
    }
    /**
     * Get amount_paid value
     * @return string|null
     */
    public function getAmount_paid()
    {
        return $this->amount_paid;
    }
    /**
     * Set amount_paid value
     * @param string $amount_paid
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setAmount_paid($amount_paid = null)
    {
        // validation for constraint: string
        if (!is_null($amount_paid) && !is_string($amount_paid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($amount_paid)), __LINE__);
        }
        $this->amount_paid = $amount_paid;
        return $this;
    }
    /**
     * Get is_void value
     * @return string|null
     */
    public function getIs_void()
    {
        return $this->is_void;
    }
    /**
     * Set is_void value
     * @param string $is_void
     * @return \StructType\CustomerInvoicesListInfo
     */
    public function setIs_void($is_void = null)
    {
        // validation for constraint: string
        if (!is_null($is_void) && !is_string($is_void)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($is_void)), __LINE__);
        }
        $this->is_void = $is_void;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CustomerInvoicesListInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
