<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DIDPricing StructType
 * @subpackage Structs
 */
class DIDPricing extends AbstractStructBase
{
    /**
     * The admin_costs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DIDCostsInfo
     */
    public $admin_costs;
    /**
     * The reseller_costs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DIDCostsInfo
     */
    public $reseller_costs;
    /**
     * The customer_costs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DIDCostsInfo
     */
    public $customer_costs;
    /**
     * Constructor method for DIDPricing
     * @uses DIDPricing::setAdmin_costs()
     * @uses DIDPricing::setReseller_costs()
     * @uses DIDPricing::setCustomer_costs()
     * @param \StructType\DIDCostsInfo $admin_costs
     * @param \StructType\DIDCostsInfo $reseller_costs
     * @param \StructType\DIDCostsInfo $customer_costs
     */
    public function __construct(\StructType\DIDCostsInfo $admin_costs = null, \StructType\DIDCostsInfo $reseller_costs = null, \StructType\DIDCostsInfo $customer_costs = null)
    {
        $this
            ->setAdmin_costs($admin_costs)
            ->setReseller_costs($reseller_costs)
            ->setCustomer_costs($customer_costs);
    }
    /**
     * Get admin_costs value
     * @return \StructType\DIDCostsInfo|null
     */
    public function getAdmin_costs()
    {
        return $this->admin_costs;
    }
    /**
     * Set admin_costs value
     * @param \StructType\DIDCostsInfo $admin_costs
     * @return \StructType\DIDPricing
     */
    public function setAdmin_costs(\StructType\DIDCostsInfo $admin_costs = null)
    {
        $this->admin_costs = $admin_costs;
        return $this;
    }
    /**
     * Get reseller_costs value
     * @return \StructType\DIDCostsInfo|null
     */
    public function getReseller_costs()
    {
        return $this->reseller_costs;
    }
    /**
     * Set reseller_costs value
     * @param \StructType\DIDCostsInfo $reseller_costs
     * @return \StructType\DIDPricing
     */
    public function setReseller_costs(\StructType\DIDCostsInfo $reseller_costs = null)
    {
        $this->reseller_costs = $reseller_costs;
        return $this;
    }
    /**
     * Get customer_costs value
     * @return \StructType\DIDCostsInfo|null
     */
    public function getCustomer_costs()
    {
        return $this->customer_costs;
    }
    /**
     * Set customer_costs value
     * @param \StructType\DIDCostsInfo $customer_costs
     * @return \StructType\DIDPricing
     */
    public function setCustomer_costs(\StructType\DIDCostsInfo $customer_costs = null)
    {
        $this->customer_costs = $customer_costs;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DIDPricing
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
