<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DestinationGroupInfo StructType
 * @subpackage Structs
 */
class DestinationGroupInfo extends AbstractStructBase
{
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The i_dest_group
     * @var int
     */
    public $i_dest_group;
    /**
     * The i_dest_group_set
     * @var int
     */
    public $i_dest_group_set;
    /**
     * The prefixes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $prefixes;
    /**
     * The used
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $used;
    /**
     * Constructor method for DestinationGroupInfo
     * @uses DestinationGroupInfo::setName()
     * @uses DestinationGroupInfo::setI_dest_group()
     * @uses DestinationGroupInfo::setI_dest_group_set()
     * @uses DestinationGroupInfo::setPrefixes()
     * @uses DestinationGroupInfo::setUsed()
     * @param string $name
     * @param int $i_dest_group
     * @param int $i_dest_group_set
     * @param string $prefixes
     * @param int $used
     */
    public function __construct($name = null, $i_dest_group = null, $i_dest_group_set = null, $prefixes = null, $used = null)
    {
        $this
            ->setName($name)
            ->setI_dest_group($i_dest_group)
            ->setI_dest_group_set($i_dest_group_set)
            ->setPrefixes($prefixes)
            ->setUsed($used);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\DestinationGroupInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get i_dest_group value
     * @return int|null
     */
    public function getI_dest_group()
    {
        return $this->i_dest_group;
    }
    /**
     * Set i_dest_group value
     * @param int $i_dest_group
     * @return \StructType\DestinationGroupInfo
     */
    public function setI_dest_group($i_dest_group = null)
    {
        // validation for constraint: int
        if (!is_null($i_dest_group) && !is_numeric($i_dest_group)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_dest_group)), __LINE__);
        }
        $this->i_dest_group = $i_dest_group;
        return $this;
    }
    /**
     * Get i_dest_group_set value
     * @return int|null
     */
    public function getI_dest_group_set()
    {
        return $this->i_dest_group_set;
    }
    /**
     * Set i_dest_group_set value
     * @param int $i_dest_group_set
     * @return \StructType\DestinationGroupInfo
     */
    public function setI_dest_group_set($i_dest_group_set = null)
    {
        // validation for constraint: int
        if (!is_null($i_dest_group_set) && !is_numeric($i_dest_group_set)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_dest_group_set)), __LINE__);
        }
        $this->i_dest_group_set = $i_dest_group_set;
        return $this;
    }
    /**
     * Get prefixes value
     * @return string|null
     */
    public function getPrefixes()
    {
        return $this->prefixes;
    }
    /**
     * Set prefixes value
     * @param string $prefixes
     * @return \StructType\DestinationGroupInfo
     */
    public function setPrefixes($prefixes = null)
    {
        // validation for constraint: string
        if (!is_null($prefixes) && !is_string($prefixes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prefixes)), __LINE__);
        }
        $this->prefixes = $prefixes;
        return $this;
    }
    /**
     * Get used value
     * @return int|null
     */
    public function getUsed()
    {
        return $this->used;
    }
    /**
     * Set used value
     * @param int $used
     * @return \StructType\DestinationGroupInfo
     */
    public function setUsed($used = null)
    {
        // validation for constraint: int
        if (!is_null($used) && !is_numeric($used)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($used)), __LINE__);
        }
        $this->used = $used;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DestinationGroupInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
