<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DialingRuleInfo StructType
 * @subpackage Structs
 */
class DialingRuleInfo extends AbstractStructBase
{
    /**
     * The i_dialing_rule
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_dialing_rule;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The rule
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DialingRuleOptionsInfo
     */
    public $rule;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The tr_rule_from_local
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $tr_rule_from_local;
    /**
     * The tr_rule_to_local
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $tr_rule_to_local;
    /**
     * The restricted
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $restricted;
    /**
     * The owner_type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $owner_type;
    /**
     * The i_owner
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_owner;
    /**
     * Constructor method for DialingRuleInfo
     * @uses DialingRuleInfo::setI_dialing_rule()
     * @uses DialingRuleInfo::setName()
     * @uses DialingRuleInfo::setRule()
     * @uses DialingRuleInfo::setDescription()
     * @uses DialingRuleInfo::setTr_rule_from_local()
     * @uses DialingRuleInfo::setTr_rule_to_local()
     * @uses DialingRuleInfo::setRestricted()
     * @uses DialingRuleInfo::setOwner_type()
     * @uses DialingRuleInfo::setI_owner()
     * @param int $i_dialing_rule
     * @param string $name
     * @param \StructType\DialingRuleOptionsInfo $rule
     * @param string $description
     * @param string $tr_rule_from_local
     * @param string $tr_rule_to_local
     * @param string $restricted
     * @param string $owner_type
     * @param int $i_owner
     */
    public function __construct($i_dialing_rule = null, $name = null, \StructType\DialingRuleOptionsInfo $rule = null, $description = null, $tr_rule_from_local = null, $tr_rule_to_local = null, $restricted = null, $owner_type = null, $i_owner = null)
    {
        $this
            ->setI_dialing_rule($i_dialing_rule)
            ->setName($name)
            ->setRule($rule)
            ->setDescription($description)
            ->setTr_rule_from_local($tr_rule_from_local)
            ->setTr_rule_to_local($tr_rule_to_local)
            ->setRestricted($restricted)
            ->setOwner_type($owner_type)
            ->setI_owner($i_owner);
    }
    /**
     * Get i_dialing_rule value
     * @return int|null
     */
    public function getI_dialing_rule()
    {
        return $this->i_dialing_rule;
    }
    /**
     * Set i_dialing_rule value
     * @param int $i_dialing_rule
     * @return \StructType\DialingRuleInfo
     */
    public function setI_dialing_rule($i_dialing_rule = null)
    {
        // validation for constraint: int
        if (!is_null($i_dialing_rule) && !is_numeric($i_dialing_rule)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_dialing_rule)), __LINE__);
        }
        $this->i_dialing_rule = $i_dialing_rule;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\DialingRuleInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get rule value
     * @return \StructType\DialingRuleOptionsInfo|null
     */
    public function getRule()
    {
        return $this->rule;
    }
    /**
     * Set rule value
     * @param \StructType\DialingRuleOptionsInfo $rule
     * @return \StructType\DialingRuleInfo
     */
    public function setRule(\StructType\DialingRuleOptionsInfo $rule = null)
    {
        $this->rule = $rule;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\DialingRuleInfo
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get tr_rule_from_local value
     * @return string|null
     */
    public function getTr_rule_from_local()
    {
        return $this->tr_rule_from_local;
    }
    /**
     * Set tr_rule_from_local value
     * @param string $tr_rule_from_local
     * @return \StructType\DialingRuleInfo
     */
    public function setTr_rule_from_local($tr_rule_from_local = null)
    {
        // validation for constraint: string
        if (!is_null($tr_rule_from_local) && !is_string($tr_rule_from_local)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tr_rule_from_local)), __LINE__);
        }
        $this->tr_rule_from_local = $tr_rule_from_local;
        return $this;
    }
    /**
     * Get tr_rule_to_local value
     * @return string|null
     */
    public function getTr_rule_to_local()
    {
        return $this->tr_rule_to_local;
    }
    /**
     * Set tr_rule_to_local value
     * @param string $tr_rule_to_local
     * @return \StructType\DialingRuleInfo
     */
    public function setTr_rule_to_local($tr_rule_to_local = null)
    {
        // validation for constraint: string
        if (!is_null($tr_rule_to_local) && !is_string($tr_rule_to_local)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($tr_rule_to_local)), __LINE__);
        }
        $this->tr_rule_to_local = $tr_rule_to_local;
        return $this;
    }
    /**
     * Get restricted value
     * @return string|null
     */
    public function getRestricted()
    {
        return $this->restricted;
    }
    /**
     * Set restricted value
     * @param string $restricted
     * @return \StructType\DialingRuleInfo
     */
    public function setRestricted($restricted = null)
    {
        // validation for constraint: string
        if (!is_null($restricted) && !is_string($restricted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($restricted)), __LINE__);
        }
        $this->restricted = $restricted;
        return $this;
    }
    /**
     * Get owner_type value
     * @return string|null
     */
    public function getOwner_type()
    {
        return $this->owner_type;
    }
    /**
     * Set owner_type value
     * @param string $owner_type
     * @return \StructType\DialingRuleInfo
     */
    public function setOwner_type($owner_type = null)
    {
        // validation for constraint: string
        if (!is_null($owner_type) && !is_string($owner_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($owner_type)), __LINE__);
        }
        $this->owner_type = $owner_type;
        return $this;
    }
    /**
     * Get i_owner value
     * @return int|null
     */
    public function getI_owner()
    {
        return $this->i_owner;
    }
    /**
     * Set i_owner value
     * @param int $i_owner
     * @return \StructType\DialingRuleInfo
     */
    public function setI_owner($i_owner = null)
    {
        // validation for constraint: int
        if (!is_null($i_owner) && !is_numeric($i_owner)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_owner)), __LINE__);
        }
        $this->i_owner = $i_owner;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DialingRuleInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
