<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DiscountInfo StructType
 * @subpackage Structs
 */
class DiscountInfo extends AbstractStructBase
{
    /**
     * The i_vd_plan
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $i_vd_plan;
    /**
     * The i_vd_dg
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_vd_dg;
    /**
     * The i_service
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_service;
    /**
     * The dg_name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dg_name;
    /**
     * The service_name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $service_name;
    /**
     * The rate_unit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rate_unit;
    /**
     * The exclusive
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $exclusive;
    /**
     * The peak_level
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $peak_level;
    /**
     * The max_peak_level
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $max_peak_level;
    /**
     * The usage_period
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $usage_period;
    /**
     * The restart
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $restart;
    /**
     * The prorate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $prorate;
    /**
     * The align_billing
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $align_billing;
    /**
     * The i_dest_group
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_dest_group;
    /**
     * The threshold_type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $threshold_type;
    /**
     * Constructor method for DiscountInfo
     * @uses DiscountInfo::setI_vd_plan()
     * @uses DiscountInfo::setI_vd_dg()
     * @uses DiscountInfo::setI_service()
     * @uses DiscountInfo::setDg_name()
     * @uses DiscountInfo::setService_name()
     * @uses DiscountInfo::setRate_unit()
     * @uses DiscountInfo::setExclusive()
     * @uses DiscountInfo::setPeak_level()
     * @uses DiscountInfo::setMax_peak_level()
     * @uses DiscountInfo::setUsage_period()
     * @uses DiscountInfo::setRestart()
     * @uses DiscountInfo::setProrate()
     * @uses DiscountInfo::setAlign_billing()
     * @uses DiscountInfo::setI_dest_group()
     * @uses DiscountInfo::setThreshold_type()
     * @param int $i_vd_plan
     * @param int $i_vd_dg
     * @param int $i_service
     * @param string $dg_name
     * @param string $service_name
     * @param string $rate_unit
     * @param string $exclusive
     * @param int $peak_level
     * @param int $max_peak_level
     * @param int $usage_period
     * @param string $restart
     * @param string $prorate
     * @param string $align_billing
     * @param int $i_dest_group
     * @param string $threshold_type
     */
    public function __construct($i_vd_plan = null, $i_vd_dg = null, $i_service = null, $dg_name = null, $service_name = null, $rate_unit = null, $exclusive = null, $peak_level = null, $max_peak_level = null, $usage_period = null, $restart = null, $prorate = null, $align_billing = null, $i_dest_group = null, $threshold_type = null)
    {
        $this
            ->setI_vd_plan($i_vd_plan)
            ->setI_vd_dg($i_vd_dg)
            ->setI_service($i_service)
            ->setDg_name($dg_name)
            ->setService_name($service_name)
            ->setRate_unit($rate_unit)
            ->setExclusive($exclusive)
            ->setPeak_level($peak_level)
            ->setMax_peak_level($max_peak_level)
            ->setUsage_period($usage_period)
            ->setRestart($restart)
            ->setProrate($prorate)
            ->setAlign_billing($align_billing)
            ->setI_dest_group($i_dest_group)
            ->setThreshold_type($threshold_type);
    }
    /**
     * Get i_vd_plan value
     * @return int
     */
    public function getI_vd_plan()
    {
        return $this->i_vd_plan;
    }
    /**
     * Set i_vd_plan value
     * @param int $i_vd_plan
     * @return \StructType\DiscountInfo
     */
    public function setI_vd_plan($i_vd_plan = null)
    {
        // validation for constraint: int
        if (!is_null($i_vd_plan) && !is_numeric($i_vd_plan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_vd_plan)), __LINE__);
        }
        $this->i_vd_plan = $i_vd_plan;
        return $this;
    }
    /**
     * Get i_vd_dg value
     * @return int|null
     */
    public function getI_vd_dg()
    {
        return $this->i_vd_dg;
    }
    /**
     * Set i_vd_dg value
     * @param int $i_vd_dg
     * @return \StructType\DiscountInfo
     */
    public function setI_vd_dg($i_vd_dg = null)
    {
        // validation for constraint: int
        if (!is_null($i_vd_dg) && !is_numeric($i_vd_dg)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_vd_dg)), __LINE__);
        }
        $this->i_vd_dg = $i_vd_dg;
        return $this;
    }
    /**
     * Get i_service value
     * @return int|null
     */
    public function getI_service()
    {
        return $this->i_service;
    }
    /**
     * Set i_service value
     * @param int $i_service
     * @return \StructType\DiscountInfo
     */
    public function setI_service($i_service = null)
    {
        // validation for constraint: int
        if (!is_null($i_service) && !is_numeric($i_service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_service)), __LINE__);
        }
        $this->i_service = $i_service;
        return $this;
    }
    /**
     * Get dg_name value
     * @return string|null
     */
    public function getDg_name()
    {
        return $this->dg_name;
    }
    /**
     * Set dg_name value
     * @param string $dg_name
     * @return \StructType\DiscountInfo
     */
    public function setDg_name($dg_name = null)
    {
        // validation for constraint: string
        if (!is_null($dg_name) && !is_string($dg_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dg_name)), __LINE__);
        }
        $this->dg_name = $dg_name;
        return $this;
    }
    /**
     * Get service_name value
     * @return string|null
     */
    public function getService_name()
    {
        return $this->service_name;
    }
    /**
     * Set service_name value
     * @param string $service_name
     * @return \StructType\DiscountInfo
     */
    public function setService_name($service_name = null)
    {
        // validation for constraint: string
        if (!is_null($service_name) && !is_string($service_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($service_name)), __LINE__);
        }
        $this->service_name = $service_name;
        return $this;
    }
    /**
     * Get rate_unit value
     * @return string|null
     */
    public function getRate_unit()
    {
        return $this->rate_unit;
    }
    /**
     * Set rate_unit value
     * @param string $rate_unit
     * @return \StructType\DiscountInfo
     */
    public function setRate_unit($rate_unit = null)
    {
        // validation for constraint: string
        if (!is_null($rate_unit) && !is_string($rate_unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rate_unit)), __LINE__);
        }
        $this->rate_unit = $rate_unit;
        return $this;
    }
    /**
     * Get exclusive value
     * @return string|null
     */
    public function getExclusive()
    {
        return $this->exclusive;
    }
    /**
     * Set exclusive value
     * @param string $exclusive
     * @return \StructType\DiscountInfo
     */
    public function setExclusive($exclusive = null)
    {
        // validation for constraint: string
        if (!is_null($exclusive) && !is_string($exclusive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($exclusive)), __LINE__);
        }
        $this->exclusive = $exclusive;
        return $this;
    }
    /**
     * Get peak_level value
     * @return int|null
     */
    public function getPeak_level()
    {
        return $this->peak_level;
    }
    /**
     * Set peak_level value
     * @param int $peak_level
     * @return \StructType\DiscountInfo
     */
    public function setPeak_level($peak_level = null)
    {
        // validation for constraint: int
        if (!is_null($peak_level) && !is_numeric($peak_level)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($peak_level)), __LINE__);
        }
        $this->peak_level = $peak_level;
        return $this;
    }
    /**
     * Get max_peak_level value
     * @return int|null
     */
    public function getMax_peak_level()
    {
        return $this->max_peak_level;
    }
    /**
     * Set max_peak_level value
     * @param int $max_peak_level
     * @return \StructType\DiscountInfo
     */
    public function setMax_peak_level($max_peak_level = null)
    {
        // validation for constraint: int
        if (!is_null($max_peak_level) && !is_numeric($max_peak_level)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($max_peak_level)), __LINE__);
        }
        $this->max_peak_level = $max_peak_level;
        return $this;
    }
    /**
     * Get usage_period value
     * @return int|null
     */
    public function getUsage_period()
    {
        return $this->usage_period;
    }
    /**
     * Set usage_period value
     * @param int $usage_period
     * @return \StructType\DiscountInfo
     */
    public function setUsage_period($usage_period = null)
    {
        // validation for constraint: int
        if (!is_null($usage_period) && !is_numeric($usage_period)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($usage_period)), __LINE__);
        }
        $this->usage_period = $usage_period;
        return $this;
    }
    /**
     * Get restart value
     * @return string|null
     */
    public function getRestart()
    {
        return $this->restart;
    }
    /**
     * Set restart value
     * @param string $restart
     * @return \StructType\DiscountInfo
     */
    public function setRestart($restart = null)
    {
        // validation for constraint: string
        if (!is_null($restart) && !is_string($restart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($restart)), __LINE__);
        }
        $this->restart = $restart;
        return $this;
    }
    /**
     * Get prorate value
     * @return string|null
     */
    public function getProrate()
    {
        return $this->prorate;
    }
    /**
     * Set prorate value
     * @param string $prorate
     * @return \StructType\DiscountInfo
     */
    public function setProrate($prorate = null)
    {
        // validation for constraint: string
        if (!is_null($prorate) && !is_string($prorate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prorate)), __LINE__);
        }
        $this->prorate = $prorate;
        return $this;
    }
    /**
     * Get align_billing value
     * @return string|null
     */
    public function getAlign_billing()
    {
        return $this->align_billing;
    }
    /**
     * Set align_billing value
     * @param string $align_billing
     * @return \StructType\DiscountInfo
     */
    public function setAlign_billing($align_billing = null)
    {
        // validation for constraint: string
        if (!is_null($align_billing) && !is_string($align_billing)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($align_billing)), __LINE__);
        }
        $this->align_billing = $align_billing;
        return $this;
    }
    /**
     * Get i_dest_group value
     * @return int|null
     */
    public function getI_dest_group()
    {
        return $this->i_dest_group;
    }
    /**
     * Set i_dest_group value
     * @param int $i_dest_group
     * @return \StructType\DiscountInfo
     */
    public function setI_dest_group($i_dest_group = null)
    {
        // validation for constraint: int
        if (!is_null($i_dest_group) && !is_numeric($i_dest_group)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_dest_group)), __LINE__);
        }
        $this->i_dest_group = $i_dest_group;
        return $this;
    }
    /**
     * Get threshold_type value
     * @return string|null
     */
    public function getThreshold_type()
    {
        return $this->threshold_type;
    }
    /**
     * Set threshold_type value
     * @param string $threshold_type
     * @return \StructType\DiscountInfo
     */
    public function setThreshold_type($threshold_type = null)
    {
        // validation for constraint: string
        if (!is_null($threshold_type) && !is_string($threshold_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($threshold_type)), __LINE__);
        }
        $this->threshold_type = $threshold_type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DiscountInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
