<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FollowMeInfo StructType
 * @subpackage Structs
 */
class FollowMeInfo extends AbstractStructBase
{
    /**
     * The i_account
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_account;
    /**
     * The i_follow_me
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_follow_me;
    /**
     * The mode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $mode;
    /**
     * The sequence
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $sequence;
    /**
     * The timeout
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $timeout;
    /**
     * The max_forwards
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $max_forwards;
    /**
     * Constructor method for FollowMeInfo
     * @uses FollowMeInfo::setI_account()
     * @uses FollowMeInfo::setI_follow_me()
     * @uses FollowMeInfo::setMode()
     * @uses FollowMeInfo::setSequence()
     * @uses FollowMeInfo::setTimeout()
     * @uses FollowMeInfo::setMax_forwards()
     * @param int $i_account
     * @param int $i_follow_me
     * @param string $mode
     * @param string $sequence
     * @param int $timeout
     * @param int $max_forwards
     */
    public function __construct($i_account = null, $i_follow_me = null, $mode = null, $sequence = null, $timeout = null, $max_forwards = null)
    {
        $this
            ->setI_account($i_account)
            ->setI_follow_me($i_follow_me)
            ->setMode($mode)
            ->setSequence($sequence)
            ->setTimeout($timeout)
            ->setMax_forwards($max_forwards);
    }
    /**
     * Get i_account value
     * @return int|null
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\FollowMeInfo
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Get i_follow_me value
     * @return int|null
     */
    public function getI_follow_me()
    {
        return $this->i_follow_me;
    }
    /**
     * Set i_follow_me value
     * @param int $i_follow_me
     * @return \StructType\FollowMeInfo
     */
    public function setI_follow_me($i_follow_me = null)
    {
        // validation for constraint: int
        if (!is_null($i_follow_me) && !is_numeric($i_follow_me)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_follow_me)), __LINE__);
        }
        $this->i_follow_me = $i_follow_me;
        return $this;
    }
    /**
     * Get mode value
     * @return string|null
     */
    public function getMode()
    {
        return $this->mode;
    }
    /**
     * Set mode value
     * @param string $mode
     * @return \StructType\FollowMeInfo
     */
    public function setMode($mode = null)
    {
        // validation for constraint: string
        if (!is_null($mode) && !is_string($mode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mode)), __LINE__);
        }
        $this->mode = $mode;
        return $this;
    }
    /**
     * Get sequence value
     * @return string|null
     */
    public function getSequence()
    {
        return $this->sequence;
    }
    /**
     * Set sequence value
     * @param string $sequence
     * @return \StructType\FollowMeInfo
     */
    public function setSequence($sequence = null)
    {
        // validation for constraint: string
        if (!is_null($sequence) && !is_string($sequence)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sequence)), __LINE__);
        }
        $this->sequence = $sequence;
        return $this;
    }
    /**
     * Get timeout value
     * @return int|null
     */
    public function getTimeout()
    {
        return $this->timeout;
    }
    /**
     * Set timeout value
     * @param int $timeout
     * @return \StructType\FollowMeInfo
     */
    public function setTimeout($timeout = null)
    {
        // validation for constraint: int
        if (!is_null($timeout) && !is_numeric($timeout)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($timeout)), __LINE__);
        }
        $this->timeout = $timeout;
        return $this;
    }
    /**
     * Get max_forwards value
     * @return int|null
     */
    public function getMax_forwards()
    {
        return $this->max_forwards;
    }
    /**
     * Set max_forwards value
     * @param int $max_forwards
     * @return \StructType\FollowMeInfo
     */
    public function setMax_forwards($max_forwards = null)
    {
        // validation for constraint: int
        if (!is_null($max_forwards) && !is_numeric($max_forwards)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($max_forwards)), __LINE__);
        }
        $this->max_forwards = $max_forwards;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FollowMeInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
