<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FullCounterInfo StructType
 * @subpackage Structs
 */
class FullCounterInfo extends AbstractStructBase
{
    /**
     * The dg_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dg_name;
    /**
     * The service_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $service_name;
    /**
     * The peak_level
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $peak_level;
    /**
     * The threshold
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $threshold;
    /**
     * The used
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $used;
    /**
     * The remaining
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $remaining;
    /**
     * The discount_level
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $discount_level;
    /**
     * The next_discount_level
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $next_discount_level;
    /**
     * The discount_info
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $discount_info;
    /**
     * The unit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $unit;
    /**
     * Constructor method for FullCounterInfo
     * @uses FullCounterInfo::setDg_name()
     * @uses FullCounterInfo::setService_name()
     * @uses FullCounterInfo::setPeak_level()
     * @uses FullCounterInfo::setThreshold()
     * @uses FullCounterInfo::setUsed()
     * @uses FullCounterInfo::setRemaining()
     * @uses FullCounterInfo::setDiscount_level()
     * @uses FullCounterInfo::setNext_discount_level()
     * @uses FullCounterInfo::setDiscount_info()
     * @uses FullCounterInfo::setUnit()
     * @param string $dg_name
     * @param string $service_name
     * @param string $peak_level
     * @param string $threshold
     * @param string $used
     * @param string $remaining
     * @param string $discount_level
     * @param string $next_discount_level
     * @param string $discount_info
     * @param string $unit
     */
    public function __construct($dg_name = null, $service_name = null, $peak_level = null, $threshold = null, $used = null, $remaining = null, $discount_level = null, $next_discount_level = null, $discount_info = null, $unit = null)
    {
        $this
            ->setDg_name($dg_name)
            ->setService_name($service_name)
            ->setPeak_level($peak_level)
            ->setThreshold($threshold)
            ->setUsed($used)
            ->setRemaining($remaining)
            ->setDiscount_level($discount_level)
            ->setNext_discount_level($next_discount_level)
            ->setDiscount_info($discount_info)
            ->setUnit($unit);
    }
    /**
     * Get dg_name value
     * @return string|null
     */
    public function getDg_name()
    {
        return $this->dg_name;
    }
    /**
     * Set dg_name value
     * @param string $dg_name
     * @return \StructType\FullCounterInfo
     */
    public function setDg_name($dg_name = null)
    {
        // validation for constraint: string
        if (!is_null($dg_name) && !is_string($dg_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dg_name)), __LINE__);
        }
        $this->dg_name = $dg_name;
        return $this;
    }
    /**
     * Get service_name value
     * @return string|null
     */
    public function getService_name()
    {
        return $this->service_name;
    }
    /**
     * Set service_name value
     * @param string $service_name
     * @return \StructType\FullCounterInfo
     */
    public function setService_name($service_name = null)
    {
        // validation for constraint: string
        if (!is_null($service_name) && !is_string($service_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($service_name)), __LINE__);
        }
        $this->service_name = $service_name;
        return $this;
    }
    /**
     * Get peak_level value
     * @return string|null
     */
    public function getPeak_level()
    {
        return $this->peak_level;
    }
    /**
     * Set peak_level value
     * @param string $peak_level
     * @return \StructType\FullCounterInfo
     */
    public function setPeak_level($peak_level = null)
    {
        // validation for constraint: string
        if (!is_null($peak_level) && !is_string($peak_level)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($peak_level)), __LINE__);
        }
        $this->peak_level = $peak_level;
        return $this;
    }
    /**
     * Get threshold value
     * @return string|null
     */
    public function getThreshold()
    {
        return $this->threshold;
    }
    /**
     * Set threshold value
     * @param string $threshold
     * @return \StructType\FullCounterInfo
     */
    public function setThreshold($threshold = null)
    {
        // validation for constraint: string
        if (!is_null($threshold) && !is_string($threshold)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($threshold)), __LINE__);
        }
        $this->threshold = $threshold;
        return $this;
    }
    /**
     * Get used value
     * @return string|null
     */
    public function getUsed()
    {
        return $this->used;
    }
    /**
     * Set used value
     * @param string $used
     * @return \StructType\FullCounterInfo
     */
    public function setUsed($used = null)
    {
        // validation for constraint: string
        if (!is_null($used) && !is_string($used)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($used)), __LINE__);
        }
        $this->used = $used;
        return $this;
    }
    /**
     * Get remaining value
     * @return string|null
     */
    public function getRemaining()
    {
        return $this->remaining;
    }
    /**
     * Set remaining value
     * @param string $remaining
     * @return \StructType\FullCounterInfo
     */
    public function setRemaining($remaining = null)
    {
        // validation for constraint: string
        if (!is_null($remaining) && !is_string($remaining)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($remaining)), __LINE__);
        }
        $this->remaining = $remaining;
        return $this;
    }
    /**
     * Get discount_level value
     * @return string|null
     */
    public function getDiscount_level()
    {
        return $this->discount_level;
    }
    /**
     * Set discount_level value
     * @param string $discount_level
     * @return \StructType\FullCounterInfo
     */
    public function setDiscount_level($discount_level = null)
    {
        // validation for constraint: string
        if (!is_null($discount_level) && !is_string($discount_level)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($discount_level)), __LINE__);
        }
        $this->discount_level = $discount_level;
        return $this;
    }
    /**
     * Get next_discount_level value
     * @return string|null
     */
    public function getNext_discount_level()
    {
        return $this->next_discount_level;
    }
    /**
     * Set next_discount_level value
     * @param string $next_discount_level
     * @return \StructType\FullCounterInfo
     */
    public function setNext_discount_level($next_discount_level = null)
    {
        // validation for constraint: string
        if (!is_null($next_discount_level) && !is_string($next_discount_level)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($next_discount_level)), __LINE__);
        }
        $this->next_discount_level = $next_discount_level;
        return $this;
    }
    /**
     * Get discount_info value
     * @return string|null
     */
    public function getDiscount_info()
    {
        return $this->discount_info;
    }
    /**
     * Set discount_info value
     * @param string $discount_info
     * @return \StructType\FullCounterInfo
     */
    public function setDiscount_info($discount_info = null)
    {
        // validation for constraint: string
        if (!is_null($discount_info) && !is_string($discount_info)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($discount_info)), __LINE__);
        }
        $this->discount_info = $discount_info;
        return $this;
    }
    /**
     * Get unit value
     * @return string|null
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @param string $unit
     * @return \StructType\FullCounterInfo
     */
    public function setUnit($unit = null)
    {
        // validation for constraint: string
        if (!is_null($unit) && !is_string($unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unit)), __LINE__);
        }
        $this->unit = $unit;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FullCounterInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
