<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GenerateUaProfileRequest StructType
 * @subpackage Structs
 */
class GenerateUaProfileRequest extends AbstractStructBase
{
    /**
     * The i_ua
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $i_ua;
    /**
     * The i_account
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $i_account;
    /**
     * The phone_type
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $phone_type;
    /**
     * The get_url
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $get_url;
    /**
     * Constructor method for GenerateUaProfileRequest
     * @uses GenerateUaProfileRequest::setI_ua()
     * @uses GenerateUaProfileRequest::setI_account()
     * @uses GenerateUaProfileRequest::setPhone_type()
     * @uses GenerateUaProfileRequest::setGet_url()
     * @param int $i_ua
     * @param int $i_account
     * @param string $phone_type
     * @param int $get_url
     */
    public function __construct($i_ua = null, $i_account = null, $phone_type = null, $get_url = null)
    {
        $this
            ->setI_ua($i_ua)
            ->setI_account($i_account)
            ->setPhone_type($phone_type)
            ->setGet_url($get_url);
    }
    /**
     * Get i_ua value
     * @return int
     */
    public function getI_ua()
    {
        return $this->i_ua;
    }
    /**
     * Set i_ua value
     * @param int $i_ua
     * @return \StructType\GenerateUaProfileRequest
     */
    public function setI_ua($i_ua = null)
    {
        // validation for constraint: int
        if (!is_null($i_ua) && !is_numeric($i_ua)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_ua)), __LINE__);
        }
        $this->i_ua = $i_ua;
        return $this;
    }
    /**
     * Get i_account value
     * @return int
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\GenerateUaProfileRequest
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Get phone_type value
     * @return string
     */
    public function getPhone_type()
    {
        return $this->phone_type;
    }
    /**
     * Set phone_type value
     * @param string $phone_type
     * @return \StructType\GenerateUaProfileRequest
     */
    public function setPhone_type($phone_type = null)
    {
        // validation for constraint: string
        if (!is_null($phone_type) && !is_string($phone_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phone_type)), __LINE__);
        }
        $this->phone_type = $phone_type;
        return $this;
    }
    /**
     * Get get_url value
     * @return int|null
     */
    public function getGet_url()
    {
        return $this->get_url;
    }
    /**
     * Set get_url value
     * @param int $get_url
     * @return \StructType\GenerateUaProfileRequest
     */
    public function setGet_url($get_url = null)
    {
        // validation for constraint: int
        if (!is_null($get_url) && !is_numeric($get_url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($get_url)), __LINE__);
        }
        $this->get_url = $get_url;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GenerateUaProfileRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
