<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAccountConsumedServiceRequest StructType
 * @subpackage Structs
 */
class GetAccountConsumedServiceRequest extends AbstractStructBase
{
    /**
     * The i_account
     * @var int
     */
    public $i_account;
    /**
     * The i_service
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_service;
    /**
     * The from_date
     * @var string
     */
    public $from_date;
    /**
     * The to_date
     * @var string
     */
    public $to_date;
    /**
     * The limit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $limit;
    /**
     * The offset
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $offset;
    /**
     * The get_total
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $get_total;
    /**
     * The show_unsuccessful
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $show_unsuccessful;
    /**
     * Constructor method for GetAccountConsumedServiceRequest
     * @uses GetAccountConsumedServiceRequest::setI_account()
     * @uses GetAccountConsumedServiceRequest::setI_service()
     * @uses GetAccountConsumedServiceRequest::setFrom_date()
     * @uses GetAccountConsumedServiceRequest::setTo_date()
     * @uses GetAccountConsumedServiceRequest::setLimit()
     * @uses GetAccountConsumedServiceRequest::setOffset()
     * @uses GetAccountConsumedServiceRequest::setGet_total()
     * @uses GetAccountConsumedServiceRequest::setShow_unsuccessful()
     * @param int $i_account
     * @param int $i_service
     * @param string $from_date
     * @param string $to_date
     * @param int $limit
     * @param int $offset
     * @param int $get_total
     * @param int $show_unsuccessful
     */
    public function __construct($i_account = null, $i_service = null, $from_date = null, $to_date = null, $limit = null, $offset = null, $get_total = null, $show_unsuccessful = null)
    {
        $this
            ->setI_account($i_account)
            ->setI_service($i_service)
            ->setFrom_date($from_date)
            ->setTo_date($to_date)
            ->setLimit($limit)
            ->setOffset($offset)
            ->setGet_total($get_total)
            ->setShow_unsuccessful($show_unsuccessful);
    }
    /**
     * Get i_account value
     * @return int|null
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Get i_service value
     * @return int|null
     */
    public function getI_service()
    {
        return $this->i_service;
    }
    /**
     * Set i_service value
     * @param int $i_service
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public function setI_service($i_service = null)
    {
        // validation for constraint: int
        if (!is_null($i_service) && !is_numeric($i_service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_service)), __LINE__);
        }
        $this->i_service = $i_service;
        return $this;
    }
    /**
     * Get from_date value
     * @return string|null
     */
    public function getFrom_date()
    {
        return $this->from_date;
    }
    /**
     * Set from_date value
     * @param string $from_date
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public function setFrom_date($from_date = null)
    {
        // validation for constraint: string
        if (!is_null($from_date) && !is_string($from_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($from_date)), __LINE__);
        }
        $this->from_date = $from_date;
        return $this;
    }
    /**
     * Get to_date value
     * @return string|null
     */
    public function getTo_date()
    {
        return $this->to_date;
    }
    /**
     * Set to_date value
     * @param string $to_date
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public function setTo_date($to_date = null)
    {
        // validation for constraint: string
        if (!is_null($to_date) && !is_string($to_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($to_date)), __LINE__);
        }
        $this->to_date = $to_date;
        return $this;
    }
    /**
     * Get limit value
     * @return int|null
     */
    public function getLimit()
    {
        return $this->limit;
    }
    /**
     * Set limit value
     * @param int $limit
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !is_numeric($limit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($limit)), __LINE__);
        }
        $this->limit = $limit;
        return $this;
    }
    /**
     * Get offset value
     * @return int|null
     */
    public function getOffset()
    {
        return $this->offset;
    }
    /**
     * Set offset value
     * @param int $offset
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public function setOffset($offset = null)
    {
        // validation for constraint: int
        if (!is_null($offset) && !is_numeric($offset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($offset)), __LINE__);
        }
        $this->offset = $offset;
        return $this;
    }
    /**
     * Get get_total value
     * @return int|null
     */
    public function getGet_total()
    {
        return $this->get_total;
    }
    /**
     * Set get_total value
     * @param int $get_total
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public function setGet_total($get_total = null)
    {
        // validation for constraint: int
        if (!is_null($get_total) && !is_numeric($get_total)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($get_total)), __LINE__);
        }
        $this->get_total = $get_total;
        return $this;
    }
    /**
     * Get show_unsuccessful value
     * @return int|null
     */
    public function getShow_unsuccessful()
    {
        return $this->show_unsuccessful;
    }
    /**
     * Set show_unsuccessful value
     * @param int $show_unsuccessful
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public function setShow_unsuccessful($show_unsuccessful = null)
    {
        // validation for constraint: int
        if (!is_null($show_unsuccessful) && !is_numeric($show_unsuccessful)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($show_unsuccessful)), __LINE__);
        }
        $this->show_unsuccessful = $show_unsuccessful;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetAccountConsumedServiceRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
