<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetConferenceSettingsResponse StructType
 * @subpackage Structs
 */
class GetConferenceSettingsResponse extends AbstractStructBase
{
    /**
     * The conf_max_allowed_session_time
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $conf_max_allowed_session_time;
    /**
     * The conf_max_pin_len
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $conf_max_pin_len;
    /**
     * The conf_max_participants_num
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $conf_max_participants_num;
    /**
     * Constructor method for GetConferenceSettingsResponse
     * @uses GetConferenceSettingsResponse::setConf_max_allowed_session_time()
     * @uses GetConferenceSettingsResponse::setConf_max_pin_len()
     * @uses GetConferenceSettingsResponse::setConf_max_participants_num()
     * @param int $conf_max_allowed_session_time
     * @param int $conf_max_pin_len
     * @param int $conf_max_participants_num
     */
    public function __construct($conf_max_allowed_session_time = null, $conf_max_pin_len = null, $conf_max_participants_num = null)
    {
        $this
            ->setConf_max_allowed_session_time($conf_max_allowed_session_time)
            ->setConf_max_pin_len($conf_max_pin_len)
            ->setConf_max_participants_num($conf_max_participants_num);
    }
    /**
     * Get conf_max_allowed_session_time value
     * @return int|null
     */
    public function getConf_max_allowed_session_time()
    {
        return $this->conf_max_allowed_session_time;
    }
    /**
     * Set conf_max_allowed_session_time value
     * @param int $conf_max_allowed_session_time
     * @return \StructType\GetConferenceSettingsResponse
     */
    public function setConf_max_allowed_session_time($conf_max_allowed_session_time = null)
    {
        // validation for constraint: int
        if (!is_null($conf_max_allowed_session_time) && !is_numeric($conf_max_allowed_session_time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($conf_max_allowed_session_time)), __LINE__);
        }
        $this->conf_max_allowed_session_time = $conf_max_allowed_session_time;
        return $this;
    }
    /**
     * Get conf_max_pin_len value
     * @return int|null
     */
    public function getConf_max_pin_len()
    {
        return $this->conf_max_pin_len;
    }
    /**
     * Set conf_max_pin_len value
     * @param int $conf_max_pin_len
     * @return \StructType\GetConferenceSettingsResponse
     */
    public function setConf_max_pin_len($conf_max_pin_len = null)
    {
        // validation for constraint: int
        if (!is_null($conf_max_pin_len) && !is_numeric($conf_max_pin_len)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($conf_max_pin_len)), __LINE__);
        }
        $this->conf_max_pin_len = $conf_max_pin_len;
        return $this;
    }
    /**
     * Get conf_max_participants_num value
     * @return int|null
     */
    public function getConf_max_participants_num()
    {
        return $this->conf_max_participants_num;
    }
    /**
     * Set conf_max_participants_num value
     * @param int $conf_max_participants_num
     * @return \StructType\GetConferenceSettingsResponse
     */
    public function setConf_max_participants_num($conf_max_participants_num = null)
    {
        // validation for constraint: int
        if (!is_null($conf_max_participants_num) && !is_numeric($conf_max_participants_num)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($conf_max_participants_num)), __LINE__);
        }
        $this->conf_max_participants_num = $conf_max_participants_num;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetConferenceSettingsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
