<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCustomerVDCounterListRequest StructType
 * @subpackage Structs
 */
class GetCustomerVDCounterListRequest extends AbstractStructBase
{
    /**
     * The i_customer
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $i_customer;
    /**
     * The service_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $service_name;
    /**
     * The dg_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dg_name;
    /**
     * The peak_level
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $peak_level;
    /**
     * Constructor method for GetCustomerVDCounterListRequest
     * @uses GetCustomerVDCounterListRequest::setI_customer()
     * @uses GetCustomerVDCounterListRequest::setService_name()
     * @uses GetCustomerVDCounterListRequest::setDg_name()
     * @uses GetCustomerVDCounterListRequest::setPeak_level()
     * @param int $i_customer
     * @param string $service_name
     * @param string $dg_name
     * @param int $peak_level
     */
    public function __construct($i_customer = null, $service_name = null, $dg_name = null, $peak_level = null)
    {
        $this
            ->setI_customer($i_customer)
            ->setService_name($service_name)
            ->setDg_name($dg_name)
            ->setPeak_level($peak_level);
    }
    /**
     * Get i_customer value
     * @return int
     */
    public function getI_customer()
    {
        return $this->i_customer;
    }
    /**
     * Set i_customer value
     * @param int $i_customer
     * @return \StructType\GetCustomerVDCounterListRequest
     */
    public function setI_customer($i_customer = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer) && !is_numeric($i_customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer)), __LINE__);
        }
        $this->i_customer = $i_customer;
        return $this;
    }
    /**
     * Get service_name value
     * @return string|null
     */
    public function getService_name()
    {
        return $this->service_name;
    }
    /**
     * Set service_name value
     * @param string $service_name
     * @return \StructType\GetCustomerVDCounterListRequest
     */
    public function setService_name($service_name = null)
    {
        // validation for constraint: string
        if (!is_null($service_name) && !is_string($service_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($service_name)), __LINE__);
        }
        $this->service_name = $service_name;
        return $this;
    }
    /**
     * Get dg_name value
     * @return string|null
     */
    public function getDg_name()
    {
        return $this->dg_name;
    }
    /**
     * Set dg_name value
     * @param string $dg_name
     * @return \StructType\GetCustomerVDCounterListRequest
     */
    public function setDg_name($dg_name = null)
    {
        // validation for constraint: string
        if (!is_null($dg_name) && !is_string($dg_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dg_name)), __LINE__);
        }
        $this->dg_name = $dg_name;
        return $this;
    }
    /**
     * Get peak_level value
     * @return int|null
     */
    public function getPeak_level()
    {
        return $this->peak_level;
    }
    /**
     * Set peak_level value
     * @param int $peak_level
     * @return \StructType\GetCustomerVDCounterListRequest
     */
    public function setPeak_level($peak_level = null)
    {
        // validation for constraint: int
        if (!is_null($peak_level) && !is_numeric($peak_level)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($peak_level)), __LINE__);
        }
        $this->peak_level = $peak_level;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetCustomerVDCounterListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
