<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCustomerVDCounterListResponse StructType
 * @subpackage Structs
 */
class GetCustomerVDCounterListResponse extends AbstractStructBase
{
    /**
     * The counter_list
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * - arrayType: pst:CounterInfo[]
     * - ref: soapenc:arrayType
     * @var \StructType\CounterInfo[]
     */
    public $counter_list;
    /**
     * Constructor method for GetCustomerVDCounterListResponse
     * @uses GetCustomerVDCounterListResponse::setCounter_list()
     * @param \StructType\CounterInfo[] $counter_list
     */
    public function __construct(array $counter_list = array())
    {
        $this
            ->setCounter_list($counter_list);
    }
    /**
     * Get counter_list value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CounterInfo[]|null
     */
    public function getCounter_list()
    {
        return isset($this->counter_list) ? $this->counter_list : null;
    }
    /**
     * Set counter_list value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CounterInfo[] $counter_list
     * @return \StructType\GetCustomerVDCounterListResponse
     */
    public function setCounter_list(array $counter_list = array())
    {
        foreach ($counter_list as $getCustomerVDCounterListResponseCounter_listItem) {
            // validation for constraint: itemType
            if (!$getCustomerVDCounterListResponseCounter_listItem instanceof \StructType\CounterInfo) {
                throw new \InvalidArgumentException(sprintf('The counter_list property can only contain items of \StructType\CounterInfo, "%s" given', is_object($getCustomerVDCounterListResponseCounter_listItem) ? get_class($getCustomerVDCounterListResponseCounter_listItem) : gettype($getCustomerVDCounterListResponseCounter_listItem)), __LINE__);
            }
        }
        if (is_null($counter_list) || (is_array($counter_list) && empty($counter_list))) {
            unset($this->counter_list);
        } else {
            $this->counter_list = $counter_list;
        }
        return $this;
    }
    /**
     * Add item to counter_list value
     * @throws \InvalidArgumentException
     * @param \StructType\CounterInfo $item
     * @return \StructType\GetCustomerVDCounterListResponse
     */
    public function addToCounter_list(\StructType\CounterInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CounterInfo) {
            throw new \InvalidArgumentException(sprintf('The counter_list property can only contain items of \StructType\CounterInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->counter_list[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetCustomerVDCounterListResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
