<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDialRuleSamplesResponse StructType
 * @subpackage Structs
 */
class GetDialRuleSamplesResponse extends AbstractStructBase
{
    /**
     * The dial_rule_samples_list
     * Meta informations extracted from the WSDL
     * - arrayType: pst:SampleDialingRulesInfo[]
     * - ref: soapenc:arrayType
     * @var \StructType\SampleDialingRulesInfo[]
     */
    public $dial_rule_samples_list;
    /**
     * Constructor method for GetDialRuleSamplesResponse
     * @uses GetDialRuleSamplesResponse::setDial_rule_samples_list()
     * @param \StructType\SampleDialingRulesInfo[] $dial_rule_samples_list
     */
    public function __construct(array $dial_rule_samples_list = array())
    {
        $this
            ->setDial_rule_samples_list($dial_rule_samples_list);
    }
    /**
     * Get dial_rule_samples_list value
     * @return \StructType\SampleDialingRulesInfo[]|null
     */
    public function getDial_rule_samples_list()
    {
        return $this->dial_rule_samples_list;
    }
    /**
     * Set dial_rule_samples_list value
     * @throws \InvalidArgumentException
     * @param \StructType\SampleDialingRulesInfo[] $dial_rule_samples_list
     * @return \StructType\GetDialRuleSamplesResponse
     */
    public function setDial_rule_samples_list(array $dial_rule_samples_list = array())
    {
        foreach ($dial_rule_samples_list as $getDialRuleSamplesResponseDial_rule_samples_listItem) {
            // validation for constraint: itemType
            if (!$getDialRuleSamplesResponseDial_rule_samples_listItem instanceof \StructType\SampleDialingRulesInfo) {
                throw new \InvalidArgumentException(sprintf('The dial_rule_samples_list property can only contain items of \StructType\SampleDialingRulesInfo, "%s" given', is_object($getDialRuleSamplesResponseDial_rule_samples_listItem) ? get_class($getDialRuleSamplesResponseDial_rule_samples_listItem) : gettype($getDialRuleSamplesResponseDial_rule_samples_listItem)), __LINE__);
            }
        }
        $this->dial_rule_samples_list = $dial_rule_samples_list;
        return $this;
    }
    /**
     * Add item to dial_rule_samples_list value
     * @throws \InvalidArgumentException
     * @param \StructType\SampleDialingRulesInfo $item
     * @return \StructType\GetDialRuleSamplesResponse
     */
    public function addToDial_rule_samples_list(\StructType\SampleDialingRulesInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SampleDialingRulesInfo) {
            throw new \InvalidArgumentException(sprintf('The dial_rule_samples_list property can only contain items of \StructType\SampleDialingRulesInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->dial_rule_samples_list[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetDialRuleSamplesResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
