<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDialingRulesListResponse StructType
 * @subpackage Structs
 */
class GetDialingRulesListResponse extends AbstractStructBase
{
    /**
     * The dialing_rules_list
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - arrayType: pst:DialingRuleInfo[]
     * - ref: soapenc:arrayType
     * @var \StructType\DialingRuleInfo[]
     */
    public $dialing_rules_list;
    /**
     * Constructor method for GetDialingRulesListResponse
     * @uses GetDialingRulesListResponse::setDialing_rules_list()
     * @param \StructType\DialingRuleInfo[] $dialing_rules_list
     */
    public function __construct(array $dialing_rules_list = array())
    {
        $this
            ->setDialing_rules_list($dialing_rules_list);
    }
    /**
     * Get dialing_rules_list value
     * @return \StructType\DialingRuleInfo[]
     */
    public function getDialing_rules_list()
    {
        return $this->dialing_rules_list;
    }
    /**
     * Set dialing_rules_list value
     * @throws \InvalidArgumentException
     * @param \StructType\DialingRuleInfo[] $dialing_rules_list
     * @return \StructType\GetDialingRulesListResponse
     */
    public function setDialing_rules_list(array $dialing_rules_list = array())
    {
        foreach ($dialing_rules_list as $getDialingRulesListResponseDialing_rules_listItem) {
            // validation for constraint: itemType
            if (!$getDialingRulesListResponseDialing_rules_listItem instanceof \StructType\DialingRuleInfo) {
                throw new \InvalidArgumentException(sprintf('The dialing_rules_list property can only contain items of \StructType\DialingRuleInfo, "%s" given', is_object($getDialingRulesListResponseDialing_rules_listItem) ? get_class($getDialingRulesListResponseDialing_rules_listItem) : gettype($getDialingRulesListResponseDialing_rules_listItem)), __LINE__);
            }
        }
        $this->dialing_rules_list = $dialing_rules_list;
        return $this;
    }
    /**
     * Add item to dialing_rules_list value
     * @throws \InvalidArgumentException
     * @param \StructType\DialingRuleInfo $item
     * @return \StructType\GetDialingRulesListResponse
     */
    public function addToDialing_rules_list(\StructType\DialingRuleInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DialingRuleInfo) {
            throw new \InvalidArgumentException(sprintf('The dialing_rules_list property can only contain items of \StructType\DialingRuleInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->dialing_rules_list[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetDialingRulesListResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
