<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetOverrideTariffListResponse StructType
 * @subpackage Structs
 */
class GetOverrideTariffListResponse extends AbstractStructBase
{
    /**
     * The override_tariff_list
     * Meta informations extracted from the WSDL
     * - arrayType: pst:OverrideTariffInfo[]
     * - ref: soapenc:arrayType
     * @var \StructType\OverrideTariffInfo[]
     */
    public $override_tariff_list;
    /**
     * Constructor method for GetOverrideTariffListResponse
     * @uses GetOverrideTariffListResponse::setOverride_tariff_list()
     * @param \StructType\OverrideTariffInfo[] $override_tariff_list
     */
    public function __construct(array $override_tariff_list = array())
    {
        $this
            ->setOverride_tariff_list($override_tariff_list);
    }
    /**
     * Get override_tariff_list value
     * @return \StructType\OverrideTariffInfo[]|null
     */
    public function getOverride_tariff_list()
    {
        return $this->override_tariff_list;
    }
    /**
     * Set override_tariff_list value
     * @throws \InvalidArgumentException
     * @param \StructType\OverrideTariffInfo[] $override_tariff_list
     * @return \StructType\GetOverrideTariffListResponse
     */
    public function setOverride_tariff_list(array $override_tariff_list = array())
    {
        foreach ($override_tariff_list as $getOverrideTariffListResponseOverride_tariff_listItem) {
            // validation for constraint: itemType
            if (!$getOverrideTariffListResponseOverride_tariff_listItem instanceof \StructType\OverrideTariffInfo) {
                throw new \InvalidArgumentException(sprintf('The override_tariff_list property can only contain items of \StructType\OverrideTariffInfo, "%s" given', is_object($getOverrideTariffListResponseOverride_tariff_listItem) ? get_class($getOverrideTariffListResponseOverride_tariff_listItem) : gettype($getOverrideTariffListResponseOverride_tariff_listItem)), __LINE__);
            }
        }
        $this->override_tariff_list = $override_tariff_list;
        return $this;
    }
    /**
     * Add item to override_tariff_list value
     * @throws \InvalidArgumentException
     * @param \StructType\OverrideTariffInfo $item
     * @return \StructType\GetOverrideTariffListResponse
     */
    public function addToOverride_tariff_list(\StructType\OverrideTariffInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OverrideTariffInfo) {
            throw new \InvalidArgumentException(sprintf('The override_tariff_list property can only contain items of \StructType\OverrideTariffInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->override_tariff_list[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetOverrideTariffListResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
