<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPeriodicalPaymentListResponse StructType
 * @subpackage Structs
 */
class GetPeriodicalPaymentListResponse extends AbstractStructBase
{
    /**
     * The periodical_payment_list
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * - arrayType: pst:PeriodicalPaymentInfo[]
     * - ref: soapenc:arrayType
     * @var \StructType\PeriodicalPaymentInfo[]
     */
    public $periodical_payment_list;
    /**
     * Constructor method for GetPeriodicalPaymentListResponse
     * @uses GetPeriodicalPaymentListResponse::setPeriodical_payment_list()
     * @param \StructType\PeriodicalPaymentInfo[] $periodical_payment_list
     */
    public function __construct(array $periodical_payment_list = array())
    {
        $this
            ->setPeriodical_payment_list($periodical_payment_list);
    }
    /**
     * Get periodical_payment_list value
     * @return \StructType\PeriodicalPaymentInfo[]
     */
    public function getPeriodical_payment_list()
    {
        return $this->periodical_payment_list;
    }
    /**
     * Set periodical_payment_list value
     * @throws \InvalidArgumentException
     * @param \StructType\PeriodicalPaymentInfo[] $periodical_payment_list
     * @return \StructType\GetPeriodicalPaymentListResponse
     */
    public function setPeriodical_payment_list(array $periodical_payment_list = array())
    {
        foreach ($periodical_payment_list as $getPeriodicalPaymentListResponsePeriodical_payment_listItem) {
            // validation for constraint: itemType
            if (!$getPeriodicalPaymentListResponsePeriodical_payment_listItem instanceof \StructType\PeriodicalPaymentInfo) {
                throw new \InvalidArgumentException(sprintf('The periodical_payment_list property can only contain items of \StructType\PeriodicalPaymentInfo, "%s" given', is_object($getPeriodicalPaymentListResponsePeriodical_payment_listItem) ? get_class($getPeriodicalPaymentListResponsePeriodical_payment_listItem) : gettype($getPeriodicalPaymentListResponsePeriodical_payment_listItem)), __LINE__);
            }
        }
        $this->periodical_payment_list = $periodical_payment_list;
        return $this;
    }
    /**
     * Add item to periodical_payment_list value
     * @throws \InvalidArgumentException
     * @param \StructType\PeriodicalPaymentInfo $item
     * @return \StructType\GetPeriodicalPaymentListResponse
     */
    public function addToPeriodical_payment_list(\StructType\PeriodicalPaymentInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PeriodicalPaymentInfo) {
            throw new \InvalidArgumentException(sprintf('The periodical_payment_list property can only contain items of \StructType\PeriodicalPaymentInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->periodical_payment_list[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPeriodicalPaymentListResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
