<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPhoneBookListRequest StructType
 * @subpackage Structs
 */
class GetPhoneBookListRequest extends AbstractStructBase
{
    /**
     * The offset
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $offset;
    /**
     * The limit
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $limit;
    /**
     * The i_account
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $i_account;
    /**
     * The phone_number_pattern
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $phone_number_pattern;
    /**
     * The get_total
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $get_total;
    /**
     * Constructor method for GetPhoneBookListRequest
     * @uses GetPhoneBookListRequest::setOffset()
     * @uses GetPhoneBookListRequest::setLimit()
     * @uses GetPhoneBookListRequest::setI_account()
     * @uses GetPhoneBookListRequest::setPhone_number_pattern()
     * @uses GetPhoneBookListRequest::setGet_total()
     * @param int $offset
     * @param int $limit
     * @param int $i_account
     * @param string $phone_number_pattern
     * @param int $get_total
     */
    public function __construct($offset = null, $limit = null, $i_account = null, $phone_number_pattern = null, $get_total = null)
    {
        $this
            ->setOffset($offset)
            ->setLimit($limit)
            ->setI_account($i_account)
            ->setPhone_number_pattern($phone_number_pattern)
            ->setGet_total($get_total);
    }
    /**
     * Get offset value
     * @return int
     */
    public function getOffset()
    {
        return $this->offset;
    }
    /**
     * Set offset value
     * @param int $offset
     * @return \StructType\GetPhoneBookListRequest
     */
    public function setOffset($offset = null)
    {
        // validation for constraint: int
        if (!is_null($offset) && !is_numeric($offset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($offset)), __LINE__);
        }
        $this->offset = $offset;
        return $this;
    }
    /**
     * Get limit value
     * @return int
     */
    public function getLimit()
    {
        return $this->limit;
    }
    /**
     * Set limit value
     * @param int $limit
     * @return \StructType\GetPhoneBookListRequest
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !is_numeric($limit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($limit)), __LINE__);
        }
        $this->limit = $limit;
        return $this;
    }
    /**
     * Get i_account value
     * @return int
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\GetPhoneBookListRequest
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Get phone_number_pattern value
     * @return string|null
     */
    public function getPhone_number_pattern()
    {
        return $this->phone_number_pattern;
    }
    /**
     * Set phone_number_pattern value
     * @param string $phone_number_pattern
     * @return \StructType\GetPhoneBookListRequest
     */
    public function setPhone_number_pattern($phone_number_pattern = null)
    {
        // validation for constraint: string
        if (!is_null($phone_number_pattern) && !is_string($phone_number_pattern)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phone_number_pattern)), __LINE__);
        }
        $this->phone_number_pattern = $phone_number_pattern;
        return $this;
    }
    /**
     * Get get_total value
     * @return int|null
     */
    public function getGet_total()
    {
        return $this->get_total;
    }
    /**
     * Set get_total value
     * @param int $get_total
     * @return \StructType\GetPhoneBookListRequest
     */
    public function setGet_total($get_total = null)
    {
        // validation for constraint: int
        if (!is_null($get_total) && !is_numeric($get_total)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($get_total)), __LINE__);
        }
        $this->get_total = $get_total;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPhoneBookListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
