<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetPromptFileResponse StructType
 * @subpackage Structs
 */
class GetPromptFileResponse extends AbstractStructBase
{
    /**
     * The prompt_status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $prompt_status;
    /**
     * The prompt_error
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $prompt_error;
    /**
     * Constructor method for GetPromptFileResponse
     * @uses GetPromptFileResponse::setPrompt_status()
     * @uses GetPromptFileResponse::setPrompt_error()
     * @param string $prompt_status
     * @param string $prompt_error
     */
    public function __construct($prompt_status = null, $prompt_error = null)
    {
        $this
            ->setPrompt_status($prompt_status)
            ->setPrompt_error($prompt_error);
    }
    /**
     * Get prompt_status value
     * @return string|null
     */
    public function getPrompt_status()
    {
        return $this->prompt_status;
    }
    /**
     * Set prompt_status value
     * @param string $prompt_status
     * @return \StructType\GetPromptFileResponse
     */
    public function setPrompt_status($prompt_status = null)
    {
        // validation for constraint: string
        if (!is_null($prompt_status) && !is_string($prompt_status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prompt_status)), __LINE__);
        }
        $this->prompt_status = $prompt_status;
        return $this;
    }
    /**
     * Get prompt_error value
     * @return string|null
     */
    public function getPrompt_error()
    {
        return $this->prompt_error;
    }
    /**
     * Set prompt_error value
     * @param string $prompt_error
     * @return \StructType\GetPromptFileResponse
     */
    public function setPrompt_error($prompt_error = null)
    {
        // validation for constraint: string
        if (!is_null($prompt_error) && !is_string($prompt_error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prompt_error)), __LINE__);
        }
        $this->prompt_error = $prompt_error;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetPromptFileResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
