<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetServiceAndRatingListRequest StructType
 * @subpackage Structs
 */
class GetServiceAndRatingListRequest extends AbstractStructBase
{
    /**
     * The i_product
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $i_product;
    /**
     * The limit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $limit;
    /**
     * The offset
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $offset;
    /**
     * The show_routing_list
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $show_routing_list;
    /**
     * Constructor method for GetServiceAndRatingListRequest
     * @uses GetServiceAndRatingListRequest::setI_product()
     * @uses GetServiceAndRatingListRequest::setLimit()
     * @uses GetServiceAndRatingListRequest::setOffset()
     * @uses GetServiceAndRatingListRequest::setShow_routing_list()
     * @param int $i_product
     * @param int $limit
     * @param int $offset
     * @param int $show_routing_list
     */
    public function __construct($i_product = null, $limit = null, $offset = null, $show_routing_list = null)
    {
        $this
            ->setI_product($i_product)
            ->setLimit($limit)
            ->setOffset($offset)
            ->setShow_routing_list($show_routing_list);
    }
    /**
     * Get i_product value
     * @return int
     */
    public function getI_product()
    {
        return $this->i_product;
    }
    /**
     * Set i_product value
     * @param int $i_product
     * @return \StructType\GetServiceAndRatingListRequest
     */
    public function setI_product($i_product = null)
    {
        // validation for constraint: int
        if (!is_null($i_product) && !is_numeric($i_product)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_product)), __LINE__);
        }
        $this->i_product = $i_product;
        return $this;
    }
    /**
     * Get limit value
     * @return int|null
     */
    public function getLimit()
    {
        return $this->limit;
    }
    /**
     * Set limit value
     * @param int $limit
     * @return \StructType\GetServiceAndRatingListRequest
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !is_numeric($limit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($limit)), __LINE__);
        }
        $this->limit = $limit;
        return $this;
    }
    /**
     * Get offset value
     * @return int|null
     */
    public function getOffset()
    {
        return $this->offset;
    }
    /**
     * Set offset value
     * @param int $offset
     * @return \StructType\GetServiceAndRatingListRequest
     */
    public function setOffset($offset = null)
    {
        // validation for constraint: int
        if (!is_null($offset) && !is_numeric($offset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($offset)), __LINE__);
        }
        $this->offset = $offset;
        return $this;
    }
    /**
     * Get show_routing_list value
     * @return int|null
     */
    public function getShow_routing_list()
    {
        return $this->show_routing_list;
    }
    /**
     * Set show_routing_list value
     * @param int $show_routing_list
     * @return \StructType\GetServiceAndRatingListRequest
     */
    public function setShow_routing_list($show_routing_list = null)
    {
        // validation for constraint: int
        if (!is_null($show_routing_list) && !is_numeric($show_routing_list)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($show_routing_list)), __LINE__);
        }
        $this->show_routing_list = $show_routing_list;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetServiceAndRatingListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
