<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSipStatusResponse StructType
 * @subpackage Structs
 */
class GetSipStatusResponse extends AbstractStructBase
{
    /**
     * The sip_status
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $sip_status;
    /**
     * The sip_info
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SipStatusInfo
     */
    public $sip_info;
    /**
     * Constructor method for GetSipStatusResponse
     * @uses GetSipStatusResponse::setSip_status()
     * @uses GetSipStatusResponse::setSip_info()
     * @param int $sip_status
     * @param \StructType\SipStatusInfo $sip_info
     */
    public function __construct($sip_status = null, \StructType\SipStatusInfo $sip_info = null)
    {
        $this
            ->setSip_status($sip_status)
            ->setSip_info($sip_info);
    }
    /**
     * Get sip_status value
     * @return int|null
     */
    public function getSip_status()
    {
        return $this->sip_status;
    }
    /**
     * Set sip_status value
     * @param int $sip_status
     * @return \StructType\GetSipStatusResponse
     */
    public function setSip_status($sip_status = null)
    {
        // validation for constraint: int
        if (!is_null($sip_status) && !is_numeric($sip_status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sip_status)), __LINE__);
        }
        $this->sip_status = $sip_status;
        return $this;
    }
    /**
     * Get sip_info value
     * @return \StructType\SipStatusInfo|null
     */
    public function getSip_info()
    {
        return $this->sip_info;
    }
    /**
     * Set sip_info value
     * @param \StructType\SipStatusInfo $sip_info
     * @return \StructType\GetSipStatusResponse
     */
    public function setSip_info(\StructType\SipStatusInfo $sip_info = null)
    {
        $this->sip_info = $sip_info;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetSipStatusResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
