<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTariffListRequest StructType
 * @subpackage Structs
 */
class GetTariffListRequest extends AbstractStructBase
{
    /**
     * The offset
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $offset;
    /**
     * The limit
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $limit;
    /**
     * The search
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $search;
    /**
     * The i_customer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_customer;
    /**
     * The i_service
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_service;
    /**
     * The applied_to
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $applied_to;
    /**
     * Constructor method for GetTariffListRequest
     * @uses GetTariffListRequest::setOffset()
     * @uses GetTariffListRequest::setLimit()
     * @uses GetTariffListRequest::setSearch()
     * @uses GetTariffListRequest::setI_customer()
     * @uses GetTariffListRequest::setI_service()
     * @uses GetTariffListRequest::setApplied_to()
     * @param int $offset
     * @param int $limit
     * @param string $search
     * @param int $i_customer
     * @param int $i_service
     * @param string $applied_to
     */
    public function __construct($offset = null, $limit = null, $search = null, $i_customer = null, $i_service = null, $applied_to = null)
    {
        $this
            ->setOffset($offset)
            ->setLimit($limit)
            ->setSearch($search)
            ->setI_customer($i_customer)
            ->setI_service($i_service)
            ->setApplied_to($applied_to);
    }
    /**
     * Get offset value
     * @return int
     */
    public function getOffset()
    {
        return $this->offset;
    }
    /**
     * Set offset value
     * @param int $offset
     * @return \StructType\GetTariffListRequest
     */
    public function setOffset($offset = null)
    {
        // validation for constraint: int
        if (!is_null($offset) && !is_numeric($offset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($offset)), __LINE__);
        }
        $this->offset = $offset;
        return $this;
    }
    /**
     * Get limit value
     * @return int
     */
    public function getLimit()
    {
        return $this->limit;
    }
    /**
     * Set limit value
     * @param int $limit
     * @return \StructType\GetTariffListRequest
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !is_numeric($limit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($limit)), __LINE__);
        }
        $this->limit = $limit;
        return $this;
    }
    /**
     * Get search value
     * @return string|null
     */
    public function getSearch()
    {
        return $this->search;
    }
    /**
     * Set search value
     * @param string $search
     * @return \StructType\GetTariffListRequest
     */
    public function setSearch($search = null)
    {
        // validation for constraint: string
        if (!is_null($search) && !is_string($search)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($search)), __LINE__);
        }
        $this->search = $search;
        return $this;
    }
    /**
     * Get i_customer value
     * @return int|null
     */
    public function getI_customer()
    {
        return $this->i_customer;
    }
    /**
     * Set i_customer value
     * @param int $i_customer
     * @return \StructType\GetTariffListRequest
     */
    public function setI_customer($i_customer = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer) && !is_numeric($i_customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer)), __LINE__);
        }
        $this->i_customer = $i_customer;
        return $this;
    }
    /**
     * Get i_service value
     * @return int|null
     */
    public function getI_service()
    {
        return $this->i_service;
    }
    /**
     * Set i_service value
     * @param int $i_service
     * @return \StructType\GetTariffListRequest
     */
    public function setI_service($i_service = null)
    {
        // validation for constraint: int
        if (!is_null($i_service) && !is_numeric($i_service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_service)), __LINE__);
        }
        $this->i_service = $i_service;
        return $this;
    }
    /**
     * Get applied_to value
     * @return string|null
     */
    public function getApplied_to()
    {
        return $this->applied_to;
    }
    /**
     * Set applied_to value
     * @param string $applied_to
     * @return \StructType\GetTariffListRequest
     */
    public function setApplied_to($applied_to = null)
    {
        // validation for constraint: string
        if (!is_null($applied_to) && !is_string($applied_to)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($applied_to)), __LINE__);
        }
        $this->applied_to = $applied_to;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetTariffListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
