<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTariffListResponse StructType
 * @subpackage Structs
 */
class GetTariffListResponse extends AbstractStructBase
{
    /**
     * The tariff_list
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - arrayType: pst:TariffInfo[]
     * - ref: soapenc:arrayType
     * @var \StructType\TariffInfo[]
     */
    public $tariff_list;
    /**
     * Constructor method for GetTariffListResponse
     * @uses GetTariffListResponse::setTariff_list()
     * @param \StructType\TariffInfo[] $tariff_list
     */
    public function __construct(array $tariff_list = array())
    {
        $this
            ->setTariff_list($tariff_list);
    }
    /**
     * Get tariff_list value
     * @return \StructType\TariffInfo[]|null
     */
    public function getTariff_list()
    {
        return $this->tariff_list;
    }
    /**
     * Set tariff_list value
     * @throws \InvalidArgumentException
     * @param \StructType\TariffInfo[] $tariff_list
     * @return \StructType\GetTariffListResponse
     */
    public function setTariff_list(array $tariff_list = array())
    {
        foreach ($tariff_list as $getTariffListResponseTariff_listItem) {
            // validation for constraint: itemType
            if (!$getTariffListResponseTariff_listItem instanceof \StructType\TariffInfo) {
                throw new \InvalidArgumentException(sprintf('The tariff_list property can only contain items of \StructType\TariffInfo, "%s" given', is_object($getTariffListResponseTariff_listItem) ? get_class($getTariffListResponseTariff_listItem) : gettype($getTariffListResponseTariff_listItem)), __LINE__);
            }
        }
        $this->tariff_list = $tariff_list;
        return $this;
    }
    /**
     * Add item to tariff_list value
     * @throws \InvalidArgumentException
     * @param \StructType\TariffInfo $item
     * @return \StructType\GetTariffListResponse
     */
    public function addToTariff_list(\StructType\TariffInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TariffInfo) {
            throw new \InvalidArgumentException(sprintf('The tariff_list property can only contain items of \StructType\TariffInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->tariff_list[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetTariffListResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
