<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetVendorAccountListRequest StructType
 * @subpackage Structs
 */
class GetVendorAccountListRequest extends AbstractStructBase
{
    /**
     * The i_vendor
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_vendor;
    /**
     * The limit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $limit;
    /**
     * The offset
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $offset;
    /**
     * Constructor method for GetVendorAccountListRequest
     * @uses GetVendorAccountListRequest::setI_vendor()
     * @uses GetVendorAccountListRequest::setLimit()
     * @uses GetVendorAccountListRequest::setOffset()
     * @param int $i_vendor
     * @param int $limit
     * @param int $offset
     */
    public function __construct($i_vendor = null, $limit = null, $offset = null)
    {
        $this
            ->setI_vendor($i_vendor)
            ->setLimit($limit)
            ->setOffset($offset);
    }
    /**
     * Get i_vendor value
     * @return int|null
     */
    public function getI_vendor()
    {
        return $this->i_vendor;
    }
    /**
     * Set i_vendor value
     * @param int $i_vendor
     * @return \StructType\GetVendorAccountListRequest
     */
    public function setI_vendor($i_vendor = null)
    {
        // validation for constraint: int
        if (!is_null($i_vendor) && !is_numeric($i_vendor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_vendor)), __LINE__);
        }
        $this->i_vendor = $i_vendor;
        return $this;
    }
    /**
     * Get limit value
     * @return int|null
     */
    public function getLimit()
    {
        return $this->limit;
    }
    /**
     * Set limit value
     * @param int $limit
     * @return \StructType\GetVendorAccountListRequest
     */
    public function setLimit($limit = null)
    {
        // validation for constraint: int
        if (!is_null($limit) && !is_numeric($limit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($limit)), __LINE__);
        }
        $this->limit = $limit;
        return $this;
    }
    /**
     * Get offset value
     * @return int|null
     */
    public function getOffset()
    {
        return $this->offset;
    }
    /**
     * Set offset value
     * @param int $offset
     * @return \StructType\GetVendorAccountListRequest
     */
    public function setOffset($offset = null)
    {
        // validation for constraint: int
        if (!is_null($offset) && !is_numeric($offset)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($offset)), __LINE__);
        }
        $this->offset = $offset;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetVendorAccountListRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
