<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetVendorBatchListResponse StructType
 * @subpackage Structs
 */
class GetVendorBatchListResponse extends AbstractStructBase
{
    /**
     * The vendor_batch_list
     * Meta informations extracted from the WSDL
     * - arrayType: pst:VendorBatchInfo[]
     * - ref: soapenc:arrayType
     * @var \StructType\VendorBatchInfo[]
     */
    public $vendor_batch_list;
    /**
     * Constructor method for GetVendorBatchListResponse
     * @uses GetVendorBatchListResponse::setVendor_batch_list()
     * @param \StructType\VendorBatchInfo[] $vendor_batch_list
     */
    public function __construct(array $vendor_batch_list = array())
    {
        $this
            ->setVendor_batch_list($vendor_batch_list);
    }
    /**
     * Get vendor_batch_list value
     * @return \StructType\VendorBatchInfo[]|null
     */
    public function getVendor_batch_list()
    {
        return $this->vendor_batch_list;
    }
    /**
     * Set vendor_batch_list value
     * @throws \InvalidArgumentException
     * @param \StructType\VendorBatchInfo[] $vendor_batch_list
     * @return \StructType\GetVendorBatchListResponse
     */
    public function setVendor_batch_list(array $vendor_batch_list = array())
    {
        foreach ($vendor_batch_list as $getVendorBatchListResponseVendor_batch_listItem) {
            // validation for constraint: itemType
            if (!$getVendorBatchListResponseVendor_batch_listItem instanceof \StructType\VendorBatchInfo) {
                throw new \InvalidArgumentException(sprintf('The vendor_batch_list property can only contain items of \StructType\VendorBatchInfo, "%s" given', is_object($getVendorBatchListResponseVendor_batch_listItem) ? get_class($getVendorBatchListResponseVendor_batch_listItem) : gettype($getVendorBatchListResponseVendor_batch_listItem)), __LINE__);
            }
        }
        $this->vendor_batch_list = $vendor_batch_list;
        return $this;
    }
    /**
     * Add item to vendor_batch_list value
     * @throws \InvalidArgumentException
     * @param \StructType\VendorBatchInfo $item
     * @return \StructType\GetVendorBatchListResponse
     */
    public function addToVendor_batch_list(\StructType\VendorBatchInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VendorBatchInfo) {
            throw new \InvalidArgumentException(sprintf('The vendor_batch_list property can only contain items of \StructType\VendorBatchInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->vendor_batch_list[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetVendorBatchListResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
