<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvoiceTemplateInfo StructType
 * @subpackage Structs
 */
class InvoiceTemplateInfo extends AbstractStructBase
{
    /**
     * The i_template
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_template;
    /**
     * The i_customer
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_customer;
    /**
     * The i_customer_class
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_customer_class;
    /**
     * The i_media_type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_media_type;
    /**
     * The i_template_type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_template_type;
    /**
     * The type_name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $type_name;
    /**
     * The is_default
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $is_default;
    /**
     * The is_system
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $is_system;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The raw_flags
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $raw_flags;
    /**
     * The managed_by
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $managed_by;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The media_name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $media_name;
    /**
     * The used
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $used;
    /**
     * Constructor method for InvoiceTemplateInfo
     * @uses InvoiceTemplateInfo::setI_template()
     * @uses InvoiceTemplateInfo::setI_customer()
     * @uses InvoiceTemplateInfo::setI_customer_class()
     * @uses InvoiceTemplateInfo::setI_media_type()
     * @uses InvoiceTemplateInfo::setI_template_type()
     * @uses InvoiceTemplateInfo::setType_name()
     * @uses InvoiceTemplateInfo::setIs_default()
     * @uses InvoiceTemplateInfo::setIs_system()
     * @uses InvoiceTemplateInfo::setName()
     * @uses InvoiceTemplateInfo::setRaw_flags()
     * @uses InvoiceTemplateInfo::setManaged_by()
     * @uses InvoiceTemplateInfo::setDescription()
     * @uses InvoiceTemplateInfo::setMedia_name()
     * @uses InvoiceTemplateInfo::setUsed()
     * @param int $i_template
     * @param int $i_customer
     * @param int $i_customer_class
     * @param int $i_media_type
     * @param int $i_template_type
     * @param string $type_name
     * @param string $is_default
     * @param int $is_system
     * @param string $name
     * @param string $raw_flags
     * @param string $managed_by
     * @param string $description
     * @param string $media_name
     * @param int $used
     */
    public function __construct($i_template = null, $i_customer = null, $i_customer_class = null, $i_media_type = null, $i_template_type = null, $type_name = null, $is_default = null, $is_system = null, $name = null, $raw_flags = null, $managed_by = null, $description = null, $media_name = null, $used = null)
    {
        $this
            ->setI_template($i_template)
            ->setI_customer($i_customer)
            ->setI_customer_class($i_customer_class)
            ->setI_media_type($i_media_type)
            ->setI_template_type($i_template_type)
            ->setType_name($type_name)
            ->setIs_default($is_default)
            ->setIs_system($is_system)
            ->setName($name)
            ->setRaw_flags($raw_flags)
            ->setManaged_by($managed_by)
            ->setDescription($description)
            ->setMedia_name($media_name)
            ->setUsed($used);
    }
    /**
     * Get i_template value
     * @return int|null
     */
    public function getI_template()
    {
        return $this->i_template;
    }
    /**
     * Set i_template value
     * @param int $i_template
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setI_template($i_template = null)
    {
        // validation for constraint: int
        if (!is_null($i_template) && !is_numeric($i_template)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_template)), __LINE__);
        }
        $this->i_template = $i_template;
        return $this;
    }
    /**
     * Get i_customer value
     * @return int|null
     */
    public function getI_customer()
    {
        return $this->i_customer;
    }
    /**
     * Set i_customer value
     * @param int $i_customer
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setI_customer($i_customer = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer) && !is_numeric($i_customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer)), __LINE__);
        }
        $this->i_customer = $i_customer;
        return $this;
    }
    /**
     * Get i_customer_class value
     * @return int|null
     */
    public function getI_customer_class()
    {
        return $this->i_customer_class;
    }
    /**
     * Set i_customer_class value
     * @param int $i_customer_class
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setI_customer_class($i_customer_class = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer_class) && !is_numeric($i_customer_class)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer_class)), __LINE__);
        }
        $this->i_customer_class = $i_customer_class;
        return $this;
    }
    /**
     * Get i_media_type value
     * @return int|null
     */
    public function getI_media_type()
    {
        return $this->i_media_type;
    }
    /**
     * Set i_media_type value
     * @param int $i_media_type
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setI_media_type($i_media_type = null)
    {
        // validation for constraint: int
        if (!is_null($i_media_type) && !is_numeric($i_media_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_media_type)), __LINE__);
        }
        $this->i_media_type = $i_media_type;
        return $this;
    }
    /**
     * Get i_template_type value
     * @return int|null
     */
    public function getI_template_type()
    {
        return $this->i_template_type;
    }
    /**
     * Set i_template_type value
     * @param int $i_template_type
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setI_template_type($i_template_type = null)
    {
        // validation for constraint: int
        if (!is_null($i_template_type) && !is_numeric($i_template_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_template_type)), __LINE__);
        }
        $this->i_template_type = $i_template_type;
        return $this;
    }
    /**
     * Get type_name value
     * @return string|null
     */
    public function getType_name()
    {
        return $this->type_name;
    }
    /**
     * Set type_name value
     * @param string $type_name
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setType_name($type_name = null)
    {
        // validation for constraint: string
        if (!is_null($type_name) && !is_string($type_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type_name)), __LINE__);
        }
        $this->type_name = $type_name;
        return $this;
    }
    /**
     * Get is_default value
     * @return string|null
     */
    public function getIs_default()
    {
        return $this->is_default;
    }
    /**
     * Set is_default value
     * @param string $is_default
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setIs_default($is_default = null)
    {
        // validation for constraint: string
        if (!is_null($is_default) && !is_string($is_default)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($is_default)), __LINE__);
        }
        $this->is_default = $is_default;
        return $this;
    }
    /**
     * Get is_system value
     * @return int|null
     */
    public function getIs_system()
    {
        return $this->is_system;
    }
    /**
     * Set is_system value
     * @param int $is_system
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setIs_system($is_system = null)
    {
        // validation for constraint: int
        if (!is_null($is_system) && !is_numeric($is_system)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($is_system)), __LINE__);
        }
        $this->is_system = $is_system;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get raw_flags value
     * @return string|null
     */
    public function getRaw_flags()
    {
        return $this->raw_flags;
    }
    /**
     * Set raw_flags value
     * @param string $raw_flags
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setRaw_flags($raw_flags = null)
    {
        // validation for constraint: string
        if (!is_null($raw_flags) && !is_string($raw_flags)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($raw_flags)), __LINE__);
        }
        $this->raw_flags = $raw_flags;
        return $this;
    }
    /**
     * Get managed_by value
     * @return string|null
     */
    public function getManaged_by()
    {
        return $this->managed_by;
    }
    /**
     * Set managed_by value
     * @param string $managed_by
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setManaged_by($managed_by = null)
    {
        // validation for constraint: string
        if (!is_null($managed_by) && !is_string($managed_by)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($managed_by)), __LINE__);
        }
        $this->managed_by = $managed_by;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get media_name value
     * @return string|null
     */
    public function getMedia_name()
    {
        return $this->media_name;
    }
    /**
     * Set media_name value
     * @param string $media_name
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setMedia_name($media_name = null)
    {
        // validation for constraint: string
        if (!is_null($media_name) && !is_string($media_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($media_name)), __LINE__);
        }
        $this->media_name = $media_name;
        return $this;
    }
    /**
     * Get used value
     * @return int|null
     */
    public function getUsed()
    {
        return $this->used;
    }
    /**
     * Set used value
     * @param int $used
     * @return \StructType\InvoiceTemplateInfo
     */
    public function setUsed($used = null)
    {
        // validation for constraint: int
        if (!is_null($used) && !is_numeric($used)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($used)), __LINE__);
        }
        $this->used = $used;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InvoiceTemplateInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
