<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MatchDestinationGroupsResponse StructType
 * @subpackage Structs
 */
class MatchDestinationGroupsResponse extends AbstractStructBase
{
    /**
     * The dest_group_list
     * Meta informations extracted from the WSDL
     * - arrayType: pst:DestinationGroupInfo[]
     * - ref: soapenc:arrayType
     * @var \StructType\DestinationGroupInfo[]
     */
    public $dest_group_list;
    /**
     * Constructor method for MatchDestinationGroupsResponse
     * @uses MatchDestinationGroupsResponse::setDest_group_list()
     * @param \StructType\DestinationGroupInfo[] $dest_group_list
     */
    public function __construct(array $dest_group_list = array())
    {
        $this
            ->setDest_group_list($dest_group_list);
    }
    /**
     * Get dest_group_list value
     * @return \StructType\DestinationGroupInfo[]|null
     */
    public function getDest_group_list()
    {
        return $this->dest_group_list;
    }
    /**
     * Set dest_group_list value
     * @throws \InvalidArgumentException
     * @param \StructType\DestinationGroupInfo[] $dest_group_list
     * @return \StructType\MatchDestinationGroupsResponse
     */
    public function setDest_group_list(array $dest_group_list = array())
    {
        foreach ($dest_group_list as $matchDestinationGroupsResponseDest_group_listItem) {
            // validation for constraint: itemType
            if (!$matchDestinationGroupsResponseDest_group_listItem instanceof \StructType\DestinationGroupInfo) {
                throw new \InvalidArgumentException(sprintf('The dest_group_list property can only contain items of \StructType\DestinationGroupInfo, "%s" given', is_object($matchDestinationGroupsResponseDest_group_listItem) ? get_class($matchDestinationGroupsResponseDest_group_listItem) : gettype($matchDestinationGroupsResponseDest_group_listItem)), __LINE__);
            }
        }
        $this->dest_group_list = $dest_group_list;
        return $this;
    }
    /**
     * Add item to dest_group_list value
     * @throws \InvalidArgumentException
     * @param \StructType\DestinationGroupInfo $item
     * @return \StructType\MatchDestinationGroupsResponse
     */
    public function addToDest_group_list(\StructType\DestinationGroupInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DestinationGroupInfo) {
            throw new \InvalidArgumentException(sprintf('The dest_group_list property can only contain items of \StructType\DestinationGroupInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->dest_group_list[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\MatchDestinationGroupsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
