<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OverrideTariffInfo StructType
 * @subpackage Structs
 */
class OverrideTariffInfo extends AbstractStructBase
{
    /**
     * The i_customer
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_customer;
    /**
     * The i_customer_override_tariff
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_customer_override_tariff;
    /**
     * The i_tariff_original
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_tariff_original;
    /**
     * The original_tariff_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $original_tariff_name;
    /**
     * The i_tariff_override
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_tariff_override;
    /**
     * The override_tariff_name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $override_tariff_name;
    /**
     * Constructor method for OverrideTariffInfo
     * @uses OverrideTariffInfo::setI_customer()
     * @uses OverrideTariffInfo::setI_customer_override_tariff()
     * @uses OverrideTariffInfo::setI_tariff_original()
     * @uses OverrideTariffInfo::setOriginal_tariff_name()
     * @uses OverrideTariffInfo::setI_tariff_override()
     * @uses OverrideTariffInfo::setOverride_tariff_name()
     * @param int $i_customer
     * @param int $i_customer_override_tariff
     * @param int $i_tariff_original
     * @param string $original_tariff_name
     * @param int $i_tariff_override
     * @param string $override_tariff_name
     */
    public function __construct($i_customer = null, $i_customer_override_tariff = null, $i_tariff_original = null, $original_tariff_name = null, $i_tariff_override = null, $override_tariff_name = null)
    {
        $this
            ->setI_customer($i_customer)
            ->setI_customer_override_tariff($i_customer_override_tariff)
            ->setI_tariff_original($i_tariff_original)
            ->setOriginal_tariff_name($original_tariff_name)
            ->setI_tariff_override($i_tariff_override)
            ->setOverride_tariff_name($override_tariff_name);
    }
    /**
     * Get i_customer value
     * @return int|null
     */
    public function getI_customer()
    {
        return $this->i_customer;
    }
    /**
     * Set i_customer value
     * @param int $i_customer
     * @return \StructType\OverrideTariffInfo
     */
    public function setI_customer($i_customer = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer) && !is_numeric($i_customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer)), __LINE__);
        }
        $this->i_customer = $i_customer;
        return $this;
    }
    /**
     * Get i_customer_override_tariff value
     * @return int|null
     */
    public function getI_customer_override_tariff()
    {
        return $this->i_customer_override_tariff;
    }
    /**
     * Set i_customer_override_tariff value
     * @param int $i_customer_override_tariff
     * @return \StructType\OverrideTariffInfo
     */
    public function setI_customer_override_tariff($i_customer_override_tariff = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer_override_tariff) && !is_numeric($i_customer_override_tariff)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer_override_tariff)), __LINE__);
        }
        $this->i_customer_override_tariff = $i_customer_override_tariff;
        return $this;
    }
    /**
     * Get i_tariff_original value
     * @return int|null
     */
    public function getI_tariff_original()
    {
        return $this->i_tariff_original;
    }
    /**
     * Set i_tariff_original value
     * @param int $i_tariff_original
     * @return \StructType\OverrideTariffInfo
     */
    public function setI_tariff_original($i_tariff_original = null)
    {
        // validation for constraint: int
        if (!is_null($i_tariff_original) && !is_numeric($i_tariff_original)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_tariff_original)), __LINE__);
        }
        $this->i_tariff_original = $i_tariff_original;
        return $this;
    }
    /**
     * Get original_tariff_name value
     * @return string|null
     */
    public function getOriginal_tariff_name()
    {
        return $this->original_tariff_name;
    }
    /**
     * Set original_tariff_name value
     * @param string $original_tariff_name
     * @return \StructType\OverrideTariffInfo
     */
    public function setOriginal_tariff_name($original_tariff_name = null)
    {
        // validation for constraint: string
        if (!is_null($original_tariff_name) && !is_string($original_tariff_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($original_tariff_name)), __LINE__);
        }
        $this->original_tariff_name = $original_tariff_name;
        return $this;
    }
    /**
     * Get i_tariff_override value
     * @return int|null
     */
    public function getI_tariff_override()
    {
        return $this->i_tariff_override;
    }
    /**
     * Set i_tariff_override value
     * @param int $i_tariff_override
     * @return \StructType\OverrideTariffInfo
     */
    public function setI_tariff_override($i_tariff_override = null)
    {
        // validation for constraint: int
        if (!is_null($i_tariff_override) && !is_numeric($i_tariff_override)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_tariff_override)), __LINE__);
        }
        $this->i_tariff_override = $i_tariff_override;
        return $this;
    }
    /**
     * Get override_tariff_name value
     * @return string|null
     */
    public function getOverride_tariff_name()
    {
        return $this->override_tariff_name;
    }
    /**
     * Set override_tariff_name value
     * @param string $override_tariff_name
     * @return \StructType\OverrideTariffInfo
     */
    public function setOverride_tariff_name($override_tariff_name = null)
    {
        // validation for constraint: string
        if (!is_null($override_tariff_name) && !is_string($override_tariff_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($override_tariff_name)), __LINE__);
        }
        $this->override_tariff_name = $override_tariff_name;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\OverrideTariffInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
