<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PerServiceInfo StructType
 * @subpackage Structs
 */
class PerServiceInfo extends AbstractStructBase
{
    /**
     * The charged_amount
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var float
     */
    public $charged_amount;
    /**
     * The charged_quantity
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $charged_quantity;
    /**
     * The total_sessions
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $total_sessions;
    /**
     * The total
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $total;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The unit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $unit;
    /**
     * The rating_base
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rating_base;
    /**
     * The rate_unit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rate_unit;
    /**
     * The rating_base_unit
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rating_base_unit;
    /**
     * The ratio
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $ratio;
    /**
     * The i_service
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_service;
    /**
     * The i_service_type
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_service_type;
    /**
     * Constructor method for PerServiceInfo
     * @uses PerServiceInfo::setCharged_amount()
     * @uses PerServiceInfo::setCharged_quantity()
     * @uses PerServiceInfo::setTotal_sessions()
     * @uses PerServiceInfo::setTotal()
     * @uses PerServiceInfo::setName()
     * @uses PerServiceInfo::setUnit()
     * @uses PerServiceInfo::setRating_base()
     * @uses PerServiceInfo::setRate_unit()
     * @uses PerServiceInfo::setRating_base_unit()
     * @uses PerServiceInfo::setRatio()
     * @uses PerServiceInfo::setI_service()
     * @uses PerServiceInfo::setI_service_type()
     * @param float $charged_amount
     * @param int $charged_quantity
     * @param int $total_sessions
     * @param int $total
     * @param string $name
     * @param string $unit
     * @param string $rating_base
     * @param string $rate_unit
     * @param string $rating_base_unit
     * @param int $ratio
     * @param int $i_service
     * @param int $i_service_type
     */
    public function __construct($charged_amount = null, $charged_quantity = null, $total_sessions = null, $total = null, $name = null, $unit = null, $rating_base = null, $rate_unit = null, $rating_base_unit = null, $ratio = null, $i_service = null, $i_service_type = null)
    {
        $this
            ->setCharged_amount($charged_amount)
            ->setCharged_quantity($charged_quantity)
            ->setTotal_sessions($total_sessions)
            ->setTotal($total)
            ->setName($name)
            ->setUnit($unit)
            ->setRating_base($rating_base)
            ->setRate_unit($rate_unit)
            ->setRating_base_unit($rating_base_unit)
            ->setRatio($ratio)
            ->setI_service($i_service)
            ->setI_service_type($i_service_type);
    }
    /**
     * Get charged_amount value
     * @return float|null
     */
    public function getCharged_amount()
    {
        return $this->charged_amount;
    }
    /**
     * Set charged_amount value
     * @param float $charged_amount
     * @return \StructType\PerServiceInfo
     */
    public function setCharged_amount($charged_amount = null)
    {
        $this->charged_amount = $charged_amount;
        return $this;
    }
    /**
     * Get charged_quantity value
     * @return int|null
     */
    public function getCharged_quantity()
    {
        return $this->charged_quantity;
    }
    /**
     * Set charged_quantity value
     * @param int $charged_quantity
     * @return \StructType\PerServiceInfo
     */
    public function setCharged_quantity($charged_quantity = null)
    {
        // validation for constraint: int
        if (!is_null($charged_quantity) && !is_numeric($charged_quantity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($charged_quantity)), __LINE__);
        }
        $this->charged_quantity = $charged_quantity;
        return $this;
    }
    /**
     * Get total_sessions value
     * @return int|null
     */
    public function getTotal_sessions()
    {
        return $this->total_sessions;
    }
    /**
     * Set total_sessions value
     * @param int $total_sessions
     * @return \StructType\PerServiceInfo
     */
    public function setTotal_sessions($total_sessions = null)
    {
        // validation for constraint: int
        if (!is_null($total_sessions) && !is_numeric($total_sessions)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($total_sessions)), __LINE__);
        }
        $this->total_sessions = $total_sessions;
        return $this;
    }
    /**
     * Get total value
     * @return int|null
     */
    public function getTotal()
    {
        return $this->total;
    }
    /**
     * Set total value
     * @param int $total
     * @return \StructType\PerServiceInfo
     */
    public function setTotal($total = null)
    {
        // validation for constraint: int
        if (!is_null($total) && !is_numeric($total)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($total)), __LINE__);
        }
        $this->total = $total;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\PerServiceInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get unit value
     * @return string|null
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @param string $unit
     * @return \StructType\PerServiceInfo
     */
    public function setUnit($unit = null)
    {
        // validation for constraint: string
        if (!is_null($unit) && !is_string($unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unit)), __LINE__);
        }
        $this->unit = $unit;
        return $this;
    }
    /**
     * Get rating_base value
     * @return string|null
     */
    public function getRating_base()
    {
        return $this->rating_base;
    }
    /**
     * Set rating_base value
     * @param string $rating_base
     * @return \StructType\PerServiceInfo
     */
    public function setRating_base($rating_base = null)
    {
        // validation for constraint: string
        if (!is_null($rating_base) && !is_string($rating_base)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rating_base)), __LINE__);
        }
        $this->rating_base = $rating_base;
        return $this;
    }
    /**
     * Get rate_unit value
     * @return string|null
     */
    public function getRate_unit()
    {
        return $this->rate_unit;
    }
    /**
     * Set rate_unit value
     * @param string $rate_unit
     * @return \StructType\PerServiceInfo
     */
    public function setRate_unit($rate_unit = null)
    {
        // validation for constraint: string
        if (!is_null($rate_unit) && !is_string($rate_unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rate_unit)), __LINE__);
        }
        $this->rate_unit = $rate_unit;
        return $this;
    }
    /**
     * Get rating_base_unit value
     * @return string|null
     */
    public function getRating_base_unit()
    {
        return $this->rating_base_unit;
    }
    /**
     * Set rating_base_unit value
     * @param string $rating_base_unit
     * @return \StructType\PerServiceInfo
     */
    public function setRating_base_unit($rating_base_unit = null)
    {
        // validation for constraint: string
        if (!is_null($rating_base_unit) && !is_string($rating_base_unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rating_base_unit)), __LINE__);
        }
        $this->rating_base_unit = $rating_base_unit;
        return $this;
    }
    /**
     * Get ratio value
     * @return int|null
     */
    public function getRatio()
    {
        return $this->ratio;
    }
    /**
     * Set ratio value
     * @param int $ratio
     * @return \StructType\PerServiceInfo
     */
    public function setRatio($ratio = null)
    {
        // validation for constraint: int
        if (!is_null($ratio) && !is_numeric($ratio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($ratio)), __LINE__);
        }
        $this->ratio = $ratio;
        return $this;
    }
    /**
     * Get i_service value
     * @return int|null
     */
    public function getI_service()
    {
        return $this->i_service;
    }
    /**
     * Set i_service value
     * @param int $i_service
     * @return \StructType\PerServiceInfo
     */
    public function setI_service($i_service = null)
    {
        // validation for constraint: int
        if (!is_null($i_service) && !is_numeric($i_service)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_service)), __LINE__);
        }
        $this->i_service = $i_service;
        return $this;
    }
    /**
     * Get i_service_type value
     * @return int|null
     */
    public function getI_service_type()
    {
        return $this->i_service_type;
    }
    /**
     * Set i_service_type value
     * @param int $i_service_type
     * @return \StructType\PerServiceInfo
     */
    public function setI_service_type($i_service_type = null)
    {
        // validation for constraint: int
        if (!is_null($i_service_type) && !is_numeric($i_service_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_service_type)), __LINE__);
        }
        $this->i_service_type = $i_service_type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PerServiceInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
