<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PhoneBookRecInfo StructType
 * @subpackage Structs
 */
class PhoneBookRecInfo extends AbstractStructBase
{
    /**
     * The i_account_phonebook
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_account_phonebook;
    /**
     * The i_account
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_account;
    /**
     * The phone_number
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $phone_number;
    /**
     * The phone_type
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $phone_type;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The dial_id
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $dial_id;
    /**
     * The lock_type
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $lock_type;
    /**
     * The unlock_time
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $unlock_time;
    /**
     * The favorite_rating
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $favorite_rating;
    /**
     * Constructor method for PhoneBookRecInfo
     * @uses PhoneBookRecInfo::setI_account_phonebook()
     * @uses PhoneBookRecInfo::setI_account()
     * @uses PhoneBookRecInfo::setPhone_number()
     * @uses PhoneBookRecInfo::setPhone_type()
     * @uses PhoneBookRecInfo::setName()
     * @uses PhoneBookRecInfo::setDial_id()
     * @uses PhoneBookRecInfo::setLock_type()
     * @uses PhoneBookRecInfo::setUnlock_time()
     * @uses PhoneBookRecInfo::setFavorite_rating()
     * @param int $i_account_phonebook
     * @param int $i_account
     * @param string $phone_number
     * @param string $phone_type
     * @param string $name
     * @param string $dial_id
     * @param string $lock_type
     * @param string $unlock_time
     * @param string $favorite_rating
     */
    public function __construct($i_account_phonebook = null, $i_account = null, $phone_number = null, $phone_type = null, $name = null, $dial_id = null, $lock_type = null, $unlock_time = null, $favorite_rating = null)
    {
        $this
            ->setI_account_phonebook($i_account_phonebook)
            ->setI_account($i_account)
            ->setPhone_number($phone_number)
            ->setPhone_type($phone_type)
            ->setName($name)
            ->setDial_id($dial_id)
            ->setLock_type($lock_type)
            ->setUnlock_time($unlock_time)
            ->setFavorite_rating($favorite_rating);
    }
    /**
     * Get i_account_phonebook value
     * @return int|null
     */
    public function getI_account_phonebook()
    {
        return $this->i_account_phonebook;
    }
    /**
     * Set i_account_phonebook value
     * @param int $i_account_phonebook
     * @return \StructType\PhoneBookRecInfo
     */
    public function setI_account_phonebook($i_account_phonebook = null)
    {
        // validation for constraint: int
        if (!is_null($i_account_phonebook) && !is_numeric($i_account_phonebook)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account_phonebook)), __LINE__);
        }
        $this->i_account_phonebook = $i_account_phonebook;
        return $this;
    }
    /**
     * Get i_account value
     * @return int|null
     */
    public function getI_account()
    {
        return $this->i_account;
    }
    /**
     * Set i_account value
     * @param int $i_account
     * @return \StructType\PhoneBookRecInfo
     */
    public function setI_account($i_account = null)
    {
        // validation for constraint: int
        if (!is_null($i_account) && !is_numeric($i_account)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_account)), __LINE__);
        }
        $this->i_account = $i_account;
        return $this;
    }
    /**
     * Get phone_number value
     * @return string|null
     */
    public function getPhone_number()
    {
        return $this->phone_number;
    }
    /**
     * Set phone_number value
     * @param string $phone_number
     * @return \StructType\PhoneBookRecInfo
     */
    public function setPhone_number($phone_number = null)
    {
        // validation for constraint: string
        if (!is_null($phone_number) && !is_string($phone_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phone_number)), __LINE__);
        }
        $this->phone_number = $phone_number;
        return $this;
    }
    /**
     * Get phone_type value
     * @return string|null
     */
    public function getPhone_type()
    {
        return $this->phone_type;
    }
    /**
     * Set phone_type value
     * @param string $phone_type
     * @return \StructType\PhoneBookRecInfo
     */
    public function setPhone_type($phone_type = null)
    {
        // validation for constraint: string
        if (!is_null($phone_type) && !is_string($phone_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($phone_type)), __LINE__);
        }
        $this->phone_type = $phone_type;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\PhoneBookRecInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get dial_id value
     * @return string|null
     */
    public function getDial_id()
    {
        return $this->dial_id;
    }
    /**
     * Set dial_id value
     * @param string $dial_id
     * @return \StructType\PhoneBookRecInfo
     */
    public function setDial_id($dial_id = null)
    {
        // validation for constraint: string
        if (!is_null($dial_id) && !is_string($dial_id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dial_id)), __LINE__);
        }
        $this->dial_id = $dial_id;
        return $this;
    }
    /**
     * Get lock_type value
     * @return string|null
     */
    public function getLock_type()
    {
        return $this->lock_type;
    }
    /**
     * Set lock_type value
     * @param string $lock_type
     * @return \StructType\PhoneBookRecInfo
     */
    public function setLock_type($lock_type = null)
    {
        // validation for constraint: string
        if (!is_null($lock_type) && !is_string($lock_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lock_type)), __LINE__);
        }
        $this->lock_type = $lock_type;
        return $this;
    }
    /**
     * Get unlock_time value
     * @return string|null
     */
    public function getUnlock_time()
    {
        return $this->unlock_time;
    }
    /**
     * Set unlock_time value
     * @param string $unlock_time
     * @return \StructType\PhoneBookRecInfo
     */
    public function setUnlock_time($unlock_time = null)
    {
        // validation for constraint: string
        if (!is_null($unlock_time) && !is_string($unlock_time)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unlock_time)), __LINE__);
        }
        $this->unlock_time = $unlock_time;
        return $this;
    }
    /**
     * Get favorite_rating value
     * @return string|null
     */
    public function getFavorite_rating()
    {
        return $this->favorite_rating;
    }
    /**
     * Set favorite_rating value
     * @param string $favorite_rating
     * @return \StructType\PhoneBookRecInfo
     */
    public function setFavorite_rating($favorite_rating = null)
    {
        // validation for constraint: string
        if (!is_null($favorite_rating) && !is_string($favorite_rating)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($favorite_rating)), __LINE__);
        }
        $this->favorite_rating = $favorite_rating;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PhoneBookRecInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
