<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoutingPlanInfo StructType
 * @subpackage Structs
 */
class RoutingPlanInfo extends AbstractStructBase
{
    /**
     * The i_routing_plan
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_routing_plan;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The profit_guarantee
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $profit_guarantee;
    /**
     * The profit_monitor
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $profit_monitor;
    /**
     * The profit_min_abs
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $profit_min_abs;
    /**
     * The profit_min_rel
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $profit_min_rel;
    /**
     * The profit_combination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $profit_combination;
    /**
     * The profit_dispersion
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $profit_dispersion;
    /**
     * The selection_code
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $selection_code;
    /**
     * The utilization_cost_diff_limit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var float
     */
    public $utilization_cost_diff_limit;
    /**
     * The override_routes_enabled
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $override_routes_enabled;
    /**
     * The categories_enabled
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $categories_enabled;
    /**
     * The i_dest_group_set
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_dest_group_set;
    /**
     * The no_delete
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $no_delete;
    /**
     * Constructor method for RoutingPlanInfo
     * @uses RoutingPlanInfo::setI_routing_plan()
     * @uses RoutingPlanInfo::setName()
     * @uses RoutingPlanInfo::setDescription()
     * @uses RoutingPlanInfo::setProfit_guarantee()
     * @uses RoutingPlanInfo::setProfit_monitor()
     * @uses RoutingPlanInfo::setProfit_min_abs()
     * @uses RoutingPlanInfo::setProfit_min_rel()
     * @uses RoutingPlanInfo::setProfit_combination()
     * @uses RoutingPlanInfo::setProfit_dispersion()
     * @uses RoutingPlanInfo::setSelection_code()
     * @uses RoutingPlanInfo::setUtilization_cost_diff_limit()
     * @uses RoutingPlanInfo::setOverride_routes_enabled()
     * @uses RoutingPlanInfo::setCategories_enabled()
     * @uses RoutingPlanInfo::setI_dest_group_set()
     * @uses RoutingPlanInfo::setNo_delete()
     * @param int $i_routing_plan
     * @param string $name
     * @param string $description
     * @param string $profit_guarantee
     * @param string $profit_monitor
     * @param float $profit_min_abs
     * @param float $profit_min_rel
     * @param string $profit_combination
     * @param float $profit_dispersion
     * @param string $selection_code
     * @param float $utilization_cost_diff_limit
     * @param string $override_routes_enabled
     * @param string $categories_enabled
     * @param int $i_dest_group_set
     * @param int $no_delete
     */
    public function __construct($i_routing_plan = null, $name = null, $description = null, $profit_guarantee = null, $profit_monitor = null, $profit_min_abs = null, $profit_min_rel = null, $profit_combination = null, $profit_dispersion = null, $selection_code = null, $utilization_cost_diff_limit = null, $override_routes_enabled = null, $categories_enabled = null, $i_dest_group_set = null, $no_delete = null)
    {
        $this
            ->setI_routing_plan($i_routing_plan)
            ->setName($name)
            ->setDescription($description)
            ->setProfit_guarantee($profit_guarantee)
            ->setProfit_monitor($profit_monitor)
            ->setProfit_min_abs($profit_min_abs)
            ->setProfit_min_rel($profit_min_rel)
            ->setProfit_combination($profit_combination)
            ->setProfit_dispersion($profit_dispersion)
            ->setSelection_code($selection_code)
            ->setUtilization_cost_diff_limit($utilization_cost_diff_limit)
            ->setOverride_routes_enabled($override_routes_enabled)
            ->setCategories_enabled($categories_enabled)
            ->setI_dest_group_set($i_dest_group_set)
            ->setNo_delete($no_delete);
    }
    /**
     * Get i_routing_plan value
     * @return int|null
     */
    public function getI_routing_plan()
    {
        return $this->i_routing_plan;
    }
    /**
     * Set i_routing_plan value
     * @param int $i_routing_plan
     * @return \StructType\RoutingPlanInfo
     */
    public function setI_routing_plan($i_routing_plan = null)
    {
        // validation for constraint: int
        if (!is_null($i_routing_plan) && !is_numeric($i_routing_plan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_routing_plan)), __LINE__);
        }
        $this->i_routing_plan = $i_routing_plan;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\RoutingPlanInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\RoutingPlanInfo
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get profit_guarantee value
     * @return string|null
     */
    public function getProfit_guarantee()
    {
        return $this->profit_guarantee;
    }
    /**
     * Set profit_guarantee value
     * @param string $profit_guarantee
     * @return \StructType\RoutingPlanInfo
     */
    public function setProfit_guarantee($profit_guarantee = null)
    {
        // validation for constraint: string
        if (!is_null($profit_guarantee) && !is_string($profit_guarantee)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($profit_guarantee)), __LINE__);
        }
        $this->profit_guarantee = $profit_guarantee;
        return $this;
    }
    /**
     * Get profit_monitor value
     * @return string|null
     */
    public function getProfit_monitor()
    {
        return $this->profit_monitor;
    }
    /**
     * Set profit_monitor value
     * @param string $profit_monitor
     * @return \StructType\RoutingPlanInfo
     */
    public function setProfit_monitor($profit_monitor = null)
    {
        // validation for constraint: string
        if (!is_null($profit_monitor) && !is_string($profit_monitor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($profit_monitor)), __LINE__);
        }
        $this->profit_monitor = $profit_monitor;
        return $this;
    }
    /**
     * Get profit_min_abs value
     * @return float|null
     */
    public function getProfit_min_abs()
    {
        return $this->profit_min_abs;
    }
    /**
     * Set profit_min_abs value
     * @param float $profit_min_abs
     * @return \StructType\RoutingPlanInfo
     */
    public function setProfit_min_abs($profit_min_abs = null)
    {
        $this->profit_min_abs = $profit_min_abs;
        return $this;
    }
    /**
     * Get profit_min_rel value
     * @return float|null
     */
    public function getProfit_min_rel()
    {
        return $this->profit_min_rel;
    }
    /**
     * Set profit_min_rel value
     * @param float $profit_min_rel
     * @return \StructType\RoutingPlanInfo
     */
    public function setProfit_min_rel($profit_min_rel = null)
    {
        $this->profit_min_rel = $profit_min_rel;
        return $this;
    }
    /**
     * Get profit_combination value
     * @return string|null
     */
    public function getProfit_combination()
    {
        return $this->profit_combination;
    }
    /**
     * Set profit_combination value
     * @param string $profit_combination
     * @return \StructType\RoutingPlanInfo
     */
    public function setProfit_combination($profit_combination = null)
    {
        // validation for constraint: string
        if (!is_null($profit_combination) && !is_string($profit_combination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($profit_combination)), __LINE__);
        }
        $this->profit_combination = $profit_combination;
        return $this;
    }
    /**
     * Get profit_dispersion value
     * @return float|null
     */
    public function getProfit_dispersion()
    {
        return $this->profit_dispersion;
    }
    /**
     * Set profit_dispersion value
     * @param float $profit_dispersion
     * @return \StructType\RoutingPlanInfo
     */
    public function setProfit_dispersion($profit_dispersion = null)
    {
        $this->profit_dispersion = $profit_dispersion;
        return $this;
    }
    /**
     * Get selection_code value
     * @return string|null
     */
    public function getSelection_code()
    {
        return $this->selection_code;
    }
    /**
     * Set selection_code value
     * @param string $selection_code
     * @return \StructType\RoutingPlanInfo
     */
    public function setSelection_code($selection_code = null)
    {
        // validation for constraint: string
        if (!is_null($selection_code) && !is_string($selection_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($selection_code)), __LINE__);
        }
        $this->selection_code = $selection_code;
        return $this;
    }
    /**
     * Get utilization_cost_diff_limit value
     * @return float|null
     */
    public function getUtilization_cost_diff_limit()
    {
        return $this->utilization_cost_diff_limit;
    }
    /**
     * Set utilization_cost_diff_limit value
     * @param float $utilization_cost_diff_limit
     * @return \StructType\RoutingPlanInfo
     */
    public function setUtilization_cost_diff_limit($utilization_cost_diff_limit = null)
    {
        $this->utilization_cost_diff_limit = $utilization_cost_diff_limit;
        return $this;
    }
    /**
     * Get override_routes_enabled value
     * @return string|null
     */
    public function getOverride_routes_enabled()
    {
        return $this->override_routes_enabled;
    }
    /**
     * Set override_routes_enabled value
     * @param string $override_routes_enabled
     * @return \StructType\RoutingPlanInfo
     */
    public function setOverride_routes_enabled($override_routes_enabled = null)
    {
        // validation for constraint: string
        if (!is_null($override_routes_enabled) && !is_string($override_routes_enabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($override_routes_enabled)), __LINE__);
        }
        $this->override_routes_enabled = $override_routes_enabled;
        return $this;
    }
    /**
     * Get categories_enabled value
     * @return string|null
     */
    public function getCategories_enabled()
    {
        return $this->categories_enabled;
    }
    /**
     * Set categories_enabled value
     * @param string $categories_enabled
     * @return \StructType\RoutingPlanInfo
     */
    public function setCategories_enabled($categories_enabled = null)
    {
        // validation for constraint: string
        if (!is_null($categories_enabled) && !is_string($categories_enabled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($categories_enabled)), __LINE__);
        }
        $this->categories_enabled = $categories_enabled;
        return $this;
    }
    /**
     * Get i_dest_group_set value
     * @return int|null
     */
    public function getI_dest_group_set()
    {
        return $this->i_dest_group_set;
    }
    /**
     * Set i_dest_group_set value
     * @param int $i_dest_group_set
     * @return \StructType\RoutingPlanInfo
     */
    public function setI_dest_group_set($i_dest_group_set = null)
    {
        // validation for constraint: int
        if (!is_null($i_dest_group_set) && !is_numeric($i_dest_group_set)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_dest_group_set)), __LINE__);
        }
        $this->i_dest_group_set = $i_dest_group_set;
        return $this;
    }
    /**
     * Get no_delete value
     * @return int|null
     */
    public function getNo_delete()
    {
        return $this->no_delete;
    }
    /**
     * Set no_delete value
     * @param int $no_delete
     * @return \StructType\RoutingPlanInfo
     */
    public function setNo_delete($no_delete = null)
    {
        // validation for constraint: int
        if (!is_null($no_delete) && !is_numeric($no_delete)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($no_delete)), __LINE__);
        }
        $this->no_delete = $no_delete;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RoutingPlanInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
