<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SampleDialingRulesInfo StructType
 * @subpackage Structs
 */
class SampleDialingRulesInfo extends AbstractStructBase
{
    /**
     * The i_dialing_rule
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $i_dialing_rule;
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The rule
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $rule;
    /**
     * The description
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $description;
    /**
     * The options
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DialingRuleOptionsInfo
     */
    public $options;
    /**
     * Constructor method for SampleDialingRulesInfo
     * @uses SampleDialingRulesInfo::setI_dialing_rule()
     * @uses SampleDialingRulesInfo::setName()
     * @uses SampleDialingRulesInfo::setRule()
     * @uses SampleDialingRulesInfo::setDescription()
     * @uses SampleDialingRulesInfo::setOptions()
     * @param int $i_dialing_rule
     * @param string $name
     * @param string $rule
     * @param string $description
     * @param \StructType\DialingRuleOptionsInfo $options
     */
    public function __construct($i_dialing_rule = null, $name = null, $rule = null, $description = null, \StructType\DialingRuleOptionsInfo $options = null)
    {
        $this
            ->setI_dialing_rule($i_dialing_rule)
            ->setName($name)
            ->setRule($rule)
            ->setDescription($description)
            ->setOptions($options);
    }
    /**
     * Get i_dialing_rule value
     * @return int|null
     */
    public function getI_dialing_rule()
    {
        return $this->i_dialing_rule;
    }
    /**
     * Set i_dialing_rule value
     * @param int $i_dialing_rule
     * @return \StructType\SampleDialingRulesInfo
     */
    public function setI_dialing_rule($i_dialing_rule = null)
    {
        // validation for constraint: int
        if (!is_null($i_dialing_rule) && !is_numeric($i_dialing_rule)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_dialing_rule)), __LINE__);
        }
        $this->i_dialing_rule = $i_dialing_rule;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\SampleDialingRulesInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get rule value
     * @return string|null
     */
    public function getRule()
    {
        return $this->rule;
    }
    /**
     * Set rule value
     * @param string $rule
     * @return \StructType\SampleDialingRulesInfo
     */
    public function setRule($rule = null)
    {
        // validation for constraint: string
        if (!is_null($rule) && !is_string($rule)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rule)), __LINE__);
        }
        $this->rule = $rule;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\SampleDialingRulesInfo
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get options value
     * @return \StructType\DialingRuleOptionsInfo|null
     */
    public function getOptions()
    {
        return $this->options;
    }
    /**
     * Set options value
     * @param \StructType\DialingRuleOptionsInfo $options
     * @return \StructType\SampleDialingRulesInfo
     */
    public function setOptions(\StructType\DialingRuleOptionsInfo $options = null)
    {
        $this->options = $options;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SampleDialingRulesInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
