<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceAndRatingRoutingInfo StructType
 * @subpackage Structs
 */
class ServiceAndRatingRoutingInfo extends AbstractStructBase
{
    /**
     * The i_acc_routing_tariff
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_acc_routing_tariff;
    /**
     * The i_routing_plan
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_routing_plan;
    /**
     * The i_accessibility
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_accessibility;
    /**
     * The i_tariff
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_tariff;
    /**
     * The i_tariff_reseller
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_tariff_reseller;
    /**
     * Constructor method for ServiceAndRatingRoutingInfo
     * @uses ServiceAndRatingRoutingInfo::setI_acc_routing_tariff()
     * @uses ServiceAndRatingRoutingInfo::setI_routing_plan()
     * @uses ServiceAndRatingRoutingInfo::setI_accessibility()
     * @uses ServiceAndRatingRoutingInfo::setI_tariff()
     * @uses ServiceAndRatingRoutingInfo::setI_tariff_reseller()
     * @param int $i_acc_routing_tariff
     * @param int $i_routing_plan
     * @param int $i_accessibility
     * @param int $i_tariff
     * @param int $i_tariff_reseller
     */
    public function __construct($i_acc_routing_tariff = null, $i_routing_plan = null, $i_accessibility = null, $i_tariff = null, $i_tariff_reseller = null)
    {
        $this
            ->setI_acc_routing_tariff($i_acc_routing_tariff)
            ->setI_routing_plan($i_routing_plan)
            ->setI_accessibility($i_accessibility)
            ->setI_tariff($i_tariff)
            ->setI_tariff_reseller($i_tariff_reseller);
    }
    /**
     * Get i_acc_routing_tariff value
     * @return int|null
     */
    public function getI_acc_routing_tariff()
    {
        return $this->i_acc_routing_tariff;
    }
    /**
     * Set i_acc_routing_tariff value
     * @param int $i_acc_routing_tariff
     * @return \StructType\ServiceAndRatingRoutingInfo
     */
    public function setI_acc_routing_tariff($i_acc_routing_tariff = null)
    {
        // validation for constraint: int
        if (!is_null($i_acc_routing_tariff) && !is_numeric($i_acc_routing_tariff)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_acc_routing_tariff)), __LINE__);
        }
        $this->i_acc_routing_tariff = $i_acc_routing_tariff;
        return $this;
    }
    /**
     * Get i_routing_plan value
     * @return int|null
     */
    public function getI_routing_plan()
    {
        return $this->i_routing_plan;
    }
    /**
     * Set i_routing_plan value
     * @param int $i_routing_plan
     * @return \StructType\ServiceAndRatingRoutingInfo
     */
    public function setI_routing_plan($i_routing_plan = null)
    {
        // validation for constraint: int
        if (!is_null($i_routing_plan) && !is_numeric($i_routing_plan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_routing_plan)), __LINE__);
        }
        $this->i_routing_plan = $i_routing_plan;
        return $this;
    }
    /**
     * Get i_accessibility value
     * @return int|null
     */
    public function getI_accessibility()
    {
        return $this->i_accessibility;
    }
    /**
     * Set i_accessibility value
     * @param int $i_accessibility
     * @return \StructType\ServiceAndRatingRoutingInfo
     */
    public function setI_accessibility($i_accessibility = null)
    {
        // validation for constraint: int
        if (!is_null($i_accessibility) && !is_numeric($i_accessibility)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_accessibility)), __LINE__);
        }
        $this->i_accessibility = $i_accessibility;
        return $this;
    }
    /**
     * Get i_tariff value
     * @return int|null
     */
    public function getI_tariff()
    {
        return $this->i_tariff;
    }
    /**
     * Set i_tariff value
     * @param int $i_tariff
     * @return \StructType\ServiceAndRatingRoutingInfo
     */
    public function setI_tariff($i_tariff = null)
    {
        // validation for constraint: int
        if (!is_null($i_tariff) && !is_numeric($i_tariff)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_tariff)), __LINE__);
        }
        $this->i_tariff = $i_tariff;
        return $this;
    }
    /**
     * Get i_tariff_reseller value
     * @return int|null
     */
    public function getI_tariff_reseller()
    {
        return $this->i_tariff_reseller;
    }
    /**
     * Set i_tariff_reseller value
     * @param int $i_tariff_reseller
     * @return \StructType\ServiceAndRatingRoutingInfo
     */
    public function setI_tariff_reseller($i_tariff_reseller = null)
    {
        // validation for constraint: int
        if (!is_null($i_tariff_reseller) && !is_numeric($i_tariff_reseller)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_tariff_reseller)), __LINE__);
        }
        $this->i_tariff_reseller = $i_tariff_reseller;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ServiceAndRatingRoutingInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
