<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StatusHistoryInfo StructType
 * @subpackage Structs
 */
class StatusHistoryInfo extends AbstractStructBase
{
    /**
     * The i_cust_stat
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_cust_stat;
    /**
     * The i_status
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $i_status;
    /**
     * The status_name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $status_name;
    /**
     * The time_stamp
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $time_stamp;
    /**
     * Constructor method for StatusHistoryInfo
     * @uses StatusHistoryInfo::setI_cust_stat()
     * @uses StatusHistoryInfo::setI_status()
     * @uses StatusHistoryInfo::setStatus_name()
     * @uses StatusHistoryInfo::setTime_stamp()
     * @param int $i_cust_stat
     * @param int $i_status
     * @param string $status_name
     * @param string $time_stamp
     */
    public function __construct($i_cust_stat = null, $i_status = null, $status_name = null, $time_stamp = null)
    {
        $this
            ->setI_cust_stat($i_cust_stat)
            ->setI_status($i_status)
            ->setStatus_name($status_name)
            ->setTime_stamp($time_stamp);
    }
    /**
     * Get i_cust_stat value
     * @return int|null
     */
    public function getI_cust_stat()
    {
        return $this->i_cust_stat;
    }
    /**
     * Set i_cust_stat value
     * @param int $i_cust_stat
     * @return \StructType\StatusHistoryInfo
     */
    public function setI_cust_stat($i_cust_stat = null)
    {
        // validation for constraint: int
        if (!is_null($i_cust_stat) && !is_numeric($i_cust_stat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_cust_stat)), __LINE__);
        }
        $this->i_cust_stat = $i_cust_stat;
        return $this;
    }
    /**
     * Get i_status value
     * @return int|null
     */
    public function getI_status()
    {
        return $this->i_status;
    }
    /**
     * Set i_status value
     * @param int $i_status
     * @return \StructType\StatusHistoryInfo
     */
    public function setI_status($i_status = null)
    {
        // validation for constraint: int
        if (!is_null($i_status) && !is_numeric($i_status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_status)), __LINE__);
        }
        $this->i_status = $i_status;
        return $this;
    }
    /**
     * Get status_name value
     * @return string|null
     */
    public function getStatus_name()
    {
        return $this->status_name;
    }
    /**
     * Set status_name value
     * @param string $status_name
     * @return \StructType\StatusHistoryInfo
     */
    public function setStatus_name($status_name = null)
    {
        // validation for constraint: string
        if (!is_null($status_name) && !is_string($status_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($status_name)), __LINE__);
        }
        $this->status_name = $status_name;
        return $this;
    }
    /**
     * Get time_stamp value
     * @return string|null
     */
    public function getTime_stamp()
    {
        return $this->time_stamp;
    }
    /**
     * Set time_stamp value
     * @param string $time_stamp
     * @return \StructType\StatusHistoryInfo
     */
    public function setTime_stamp($time_stamp = null)
    {
        // validation for constraint: string
        if (!is_null($time_stamp) && !is_string($time_stamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($time_stamp)), __LINE__);
        }
        $this->time_stamp = $time_stamp;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StatusHistoryInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
