<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TaxationOptionsBillsoft StructType
 * @subpackage Structs
 */
class TaxationOptionsBillsoft extends AbstractStructBase
{
    /**
     * The reseller_regulated
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $reseller_regulated;
    /**
     * The reseller_voipa
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $reseller_voipa;
    /**
     * The customer_type
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $customer_type;
    /**
     * The incorporated_area
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $incorporated_area;
    /**
     * The federal_exempt
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $federal_exempt;
    /**
     * The state_exempt
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $state_exempt;
    /**
     * The county_exempt
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $county_exempt;
    /**
     * The local_exempt
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $local_exempt;
    /**
     * Constructor method for TaxationOptionsBillsoft
     * @uses TaxationOptionsBillsoft::setReseller_regulated()
     * @uses TaxationOptionsBillsoft::setReseller_voipa()
     * @uses TaxationOptionsBillsoft::setCustomer_type()
     * @uses TaxationOptionsBillsoft::setIncorporated_area()
     * @uses TaxationOptionsBillsoft::setFederal_exempt()
     * @uses TaxationOptionsBillsoft::setState_exempt()
     * @uses TaxationOptionsBillsoft::setCounty_exempt()
     * @uses TaxationOptionsBillsoft::setLocal_exempt()
     * @param string $reseller_regulated
     * @param string $reseller_voipa
     * @param string $customer_type
     * @param string $incorporated_area
     * @param string $federal_exempt
     * @param string $state_exempt
     * @param string $county_exempt
     * @param string $local_exempt
     */
    public function __construct($reseller_regulated = null, $reseller_voipa = null, $customer_type = null, $incorporated_area = null, $federal_exempt = null, $state_exempt = null, $county_exempt = null, $local_exempt = null)
    {
        $this
            ->setReseller_regulated($reseller_regulated)
            ->setReseller_voipa($reseller_voipa)
            ->setCustomer_type($customer_type)
            ->setIncorporated_area($incorporated_area)
            ->setFederal_exempt($federal_exempt)
            ->setState_exempt($state_exempt)
            ->setCounty_exempt($county_exempt)
            ->setLocal_exempt($local_exempt);
    }
    /**
     * Get reseller_regulated value
     * @return string
     */
    public function getReseller_regulated()
    {
        return $this->reseller_regulated;
    }
    /**
     * Set reseller_regulated value
     * @param string $reseller_regulated
     * @return \StructType\TaxationOptionsBillsoft
     */
    public function setReseller_regulated($reseller_regulated = null)
    {
        // validation for constraint: string
        if (!is_null($reseller_regulated) && !is_string($reseller_regulated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($reseller_regulated)), __LINE__);
        }
        $this->reseller_regulated = $reseller_regulated;
        return $this;
    }
    /**
     * Get reseller_voipa value
     * @return string
     */
    public function getReseller_voipa()
    {
        return $this->reseller_voipa;
    }
    /**
     * Set reseller_voipa value
     * @param string $reseller_voipa
     * @return \StructType\TaxationOptionsBillsoft
     */
    public function setReseller_voipa($reseller_voipa = null)
    {
        // validation for constraint: string
        if (!is_null($reseller_voipa) && !is_string($reseller_voipa)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($reseller_voipa)), __LINE__);
        }
        $this->reseller_voipa = $reseller_voipa;
        return $this;
    }
    /**
     * Get customer_type value
     * @return string
     */
    public function getCustomer_type()
    {
        return $this->customer_type;
    }
    /**
     * Set customer_type value
     * @param string $customer_type
     * @return \StructType\TaxationOptionsBillsoft
     */
    public function setCustomer_type($customer_type = null)
    {
        // validation for constraint: string
        if (!is_null($customer_type) && !is_string($customer_type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($customer_type)), __LINE__);
        }
        $this->customer_type = $customer_type;
        return $this;
    }
    /**
     * Get incorporated_area value
     * @return string
     */
    public function getIncorporated_area()
    {
        return $this->incorporated_area;
    }
    /**
     * Set incorporated_area value
     * @param string $incorporated_area
     * @return \StructType\TaxationOptionsBillsoft
     */
    public function setIncorporated_area($incorporated_area = null)
    {
        // validation for constraint: string
        if (!is_null($incorporated_area) && !is_string($incorporated_area)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($incorporated_area)), __LINE__);
        }
        $this->incorporated_area = $incorporated_area;
        return $this;
    }
    /**
     * Get federal_exempt value
     * @return string
     */
    public function getFederal_exempt()
    {
        return $this->federal_exempt;
    }
    /**
     * Set federal_exempt value
     * @param string $federal_exempt
     * @return \StructType\TaxationOptionsBillsoft
     */
    public function setFederal_exempt($federal_exempt = null)
    {
        // validation for constraint: string
        if (!is_null($federal_exempt) && !is_string($federal_exempt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($federal_exempt)), __LINE__);
        }
        $this->federal_exempt = $federal_exempt;
        return $this;
    }
    /**
     * Get state_exempt value
     * @return string
     */
    public function getState_exempt()
    {
        return $this->state_exempt;
    }
    /**
     * Set state_exempt value
     * @param string $state_exempt
     * @return \StructType\TaxationOptionsBillsoft
     */
    public function setState_exempt($state_exempt = null)
    {
        // validation for constraint: string
        if (!is_null($state_exempt) && !is_string($state_exempt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($state_exempt)), __LINE__);
        }
        $this->state_exempt = $state_exempt;
        return $this;
    }
    /**
     * Get county_exempt value
     * @return string
     */
    public function getCounty_exempt()
    {
        return $this->county_exempt;
    }
    /**
     * Set county_exempt value
     * @param string $county_exempt
     * @return \StructType\TaxationOptionsBillsoft
     */
    public function setCounty_exempt($county_exempt = null)
    {
        // validation for constraint: string
        if (!is_null($county_exempt) && !is_string($county_exempt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($county_exempt)), __LINE__);
        }
        $this->county_exempt = $county_exempt;
        return $this;
    }
    /**
     * Get local_exempt value
     * @return string
     */
    public function getLocal_exempt()
    {
        return $this->local_exempt;
    }
    /**
     * Set local_exempt value
     * @param string $local_exempt
     * @return \StructType\TaxationOptionsBillsoft
     */
    public function setLocal_exempt($local_exempt = null)
    {
        // validation for constraint: string
        if (!is_null($local_exempt) && !is_string($local_exempt)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($local_exempt)), __LINE__);
        }
        $this->local_exempt = $local_exempt;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TaxationOptionsBillsoft
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
