<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TerminateCustomerRequest StructType
 * @subpackage Structs
 */
class TerminateCustomerRequest extends AbstractStructBase
{
    /**
     * The i_customer
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var int
     */
    public $i_customer;
    /**
     * The supress_notification
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $supress_notification;
    /**
     * Constructor method for TerminateCustomerRequest
     * @uses TerminateCustomerRequest::setI_customer()
     * @uses TerminateCustomerRequest::setSupress_notification()
     * @param int $i_customer
     * @param int $supress_notification
     */
    public function __construct($i_customer = null, $supress_notification = null)
    {
        $this
            ->setI_customer($i_customer)
            ->setSupress_notification($supress_notification);
    }
    /**
     * Get i_customer value
     * @return int
     */
    public function getI_customer()
    {
        return $this->i_customer;
    }
    /**
     * Set i_customer value
     * @param int $i_customer
     * @return \StructType\TerminateCustomerRequest
     */
    public function setI_customer($i_customer = null)
    {
        // validation for constraint: int
        if (!is_null($i_customer) && !is_numeric($i_customer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_customer)), __LINE__);
        }
        $this->i_customer = $i_customer;
        return $this;
    }
    /**
     * Get supress_notification value
     * @return int|null
     */
    public function getSupress_notification()
    {
        return $this->supress_notification;
    }
    /**
     * Set supress_notification value
     * @param int $supress_notification
     * @return \StructType\TerminateCustomerRequest
     */
    public function setSupress_notification($supress_notification = null)
    {
        // validation for constraint: int
        if (!is_null($supress_notification) && !is_numeric($supress_notification)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($supress_notification)), __LINE__);
        }
        $this->supress_notification = $supress_notification;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\TerminateCustomerRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
