<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WCAddRoutingPlanCategoryRequest StructType
 * @subpackage Structs
 */
class WCAddRoutingPlanCategoryRequest extends AbstractStructBase
{
    /**
     * The routing_plan_category_info
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var \StructType\WCRoutingPlanCategoryInfo
     */
    public $routing_plan_category_info;
    /**
     * The i_routing_plan
     * Meta informations extracted from the WSDL
     * - documentation: Unique ID of the plan
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var int
     */
    public $i_routing_plan;
    /**
     * Constructor method for WCAddRoutingPlanCategoryRequest
     * @uses WCAddRoutingPlanCategoryRequest::setRouting_plan_category_info()
     * @uses WCAddRoutingPlanCategoryRequest::setI_routing_plan()
     * @param \StructType\WCRoutingPlanCategoryInfo $routing_plan_category_info
     * @param int $i_routing_plan
     */
    public function __construct(\StructType\WCRoutingPlanCategoryInfo $routing_plan_category_info = null, $i_routing_plan = null)
    {
        $this
            ->setRouting_plan_category_info($routing_plan_category_info)
            ->setI_routing_plan($i_routing_plan);
    }
    /**
     * Get routing_plan_category_info value
     * @return \StructType\WCRoutingPlanCategoryInfo
     */
    public function getRouting_plan_category_info()
    {
        return $this->routing_plan_category_info;
    }
    /**
     * Set routing_plan_category_info value
     * @param \StructType\WCRoutingPlanCategoryInfo $routing_plan_category_info
     * @return \StructType\WCAddRoutingPlanCategoryRequest
     */
    public function setRouting_plan_category_info(\StructType\WCRoutingPlanCategoryInfo $routing_plan_category_info = null)
    {
        $this->routing_plan_category_info = $routing_plan_category_info;
        return $this;
    }
    /**
     * Get i_routing_plan value
     * @return int
     */
    public function getI_routing_plan()
    {
        return $this->i_routing_plan;
    }
    /**
     * Set i_routing_plan value
     * @param int $i_routing_plan
     * @return \StructType\WCAddRoutingPlanCategoryRequest
     */
    public function setI_routing_plan($i_routing_plan = null)
    {
        // validation for constraint: int
        if (!is_null($i_routing_plan) && !is_numeric($i_routing_plan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_routing_plan)), __LINE__);
        }
        $this->i_routing_plan = $i_routing_plan;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WCAddRoutingPlanCategoryRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
