<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WCAddServiceRatingResponse StructType
 * @subpackage Structs
 */
class WCAddServiceRatingResponse extends AbstractStructBase
{
    /**
     * The i_accessibility
     * Meta informations extracted from the WSDL
     * - documentation: Unique ID of the service rating record
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $i_accessibility;
    /**
     * Constructor method for WCAddServiceRatingResponse
     * @uses WCAddServiceRatingResponse::setI_accessibility()
     * @param int $i_accessibility
     */
    public function __construct($i_accessibility = null)
    {
        $this
            ->setI_accessibility($i_accessibility);
    }
    /**
     * Get i_accessibility value
     * @return int
     */
    public function getI_accessibility()
    {
        return $this->i_accessibility;
    }
    /**
     * Set i_accessibility value
     * @param int $i_accessibility
     * @return \StructType\WCAddServiceRatingResponse
     */
    public function setI_accessibility($i_accessibility = null)
    {
        // validation for constraint: int
        if (!is_null($i_accessibility) && !is_numeric($i_accessibility)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($i_accessibility)), __LINE__);
        }
        $this->i_accessibility = $i_accessibility;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\WCAddServiceRatingResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
